#include <stdio.h>
#include <sys/types.h>
#include <signal.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/wait.h>
#include <string.h>
#include <sys/ioctl.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <net/if.h>

#include "types.h"

int getIpAddress(byte ip[4], char *intf)
{
    struct ifreq ifr;
    int fd;
	struct sockaddr_in *ifr_addr_in;

	if (intf == NULL) {
		memset(ip, 0, sizeof(ip));
		return(0);
	}

	if ((fd = socket(PF_INET,SOCK_DGRAM,IPPROTO_IP)) < 0) {
		return (-1);
	}

	strncpy(ifr.ifr_name, intf, IFNAMSIZ);
	ifr.ifr_addr.sa_family = AF_INET;
	if (ioctl(fd, SIOCGIFADDR, &ifr) < 0) {
		close(fd);
		return(-2);
	}
	ifr_addr_in = (struct sockaddr_in *) &ifr.ifr_addr;
	memcpy(ip, (char *)&ifr_addr_in->sin_addr, 4);
	close(fd);
    return(0);
}

