//---------------------------------------------------------------------
// Copyright 2002, Avocent Corporation
//---------------------------------------------------------------------
// FILE         : dstypes.h 
//
// DESCRIPTION  : DS appliance data types
//
//---------------------------------------------------------------------
// AUTHOR       : David Stafford
// DATE         : Jan-04-2002
//
//---------------------------------------------------------------------
// HISTORY
//
// DATE         PROGRAMMER        MODIFICATIONS
// Jan-04-2002  David Stafford    Initial version
//
//---------------------------------------------------------------------

#ifndef __DSTYPES_H
#define __DSTYPES_H

#include <netinet/in.h> /* to get struct in_addr */

#if 0

typedef struct UniCode 
{
  // 2 byte unicode char; for ascii encoding bytes[0] is a 0 

  unsigned char bytes[ 2 ];
} UniCode;

#define isNullUniCode(ptr)   ((ptr)->bytes[0]==0&&(ptr)->bytes[1]==0)

#else
  typedef unsigned short UniCode;
  #define isNullUniCode(ptr)   (*(ptr)==0)
#endif

typedef struct RIP_ID
{
  unsigned char id[ 8 ];	// 8 bytes of packed hexidecimal codes
                          // first 6 are in use so far
} RIP_ID ;

  // use inet_ntoa() and inet_aton() to convert IP addresses 
  // between binary and ascii. 

typedef struct in_addr IP_ADDR;

// typedef struct IP_ADDR 
// {
// //  unsigned char addr[4];
// 
//   unsigned long int addr;
// } IP_ADDR ;

typedef struct MAC_ADDR 
{
  unsigned char addr[6];
} MAC_ADDR ;


#include "utf8.h"

#endif /* __DSTYPES_H */

/* end */

