//------------------------------------------------------------------------
// Copyright 2000, Cybex Computer Products Corporation
//------------------------------------------------------------------------
//
// APR-13-2000    N. Flanagan             First working mouse
//
//=============================================================================
#ifndef __NETWRAP_H
#define __NETWRAP_H


#include <unistd.h>
#include <arpa/inet.h>


// Prototypes for wrappers.c

int Socket(int family, int type, int protocol);
int Close(int sockfd);
int ClosePipe( int fds[2] );
int Setsockopt(int sockfd, int level, int optname, const void *optval, 
               socklen_t optlen);
int Accept(int fd, struct sockaddr *sa, socklen_t *salenptr);
int Bind(int fd, const struct sockaddr *sa, socklen_t salen);
int Connect(int fd, const struct sockaddr *sa, socklen_t salen);
int ConnectTimeout(int fd, const struct sockaddr *sa, socklen_t salen, int nsec);
void Listen(int fd, int backlog);
int TCP_Connect ( int port, char * ip_address, int timeout );
int TCP_Listen ( int port, char * ip_address );
int Send(int fd, const void *ptr, size_t nbytes, int flags);
int setRecvTimeout( int socket, int seconds );
ssize_t Recv(int fd, void *ptr, size_t nbytes, int flags);
int Select_read(int socket, long timeout);
void Shutdown(int fd, int how);

int Gethostname ( char * hostname_string, int len );
int Sethostname ( char * hostname_string, int len );
int Getdomainname ( char * domainname, int len );
int Setdomainname ( char * domainname, int len );

int Get_ip_address ( char * ipAddr );
int GetPeerName ( int sockfd, struct in_addr * peerAddr );

int UNIX_Listen ( char * filename );
int UNIX_Connect ( char * filename );

#endif

