//---------------------------------------------------------------------
// Copyright 2002, Cybex Computer Products Corporation
//---------------------------------------------------------------------
// FILE         : ssl.h
//
// DESCRIPTION  : 
//                
//
//---------------------------------------------------------------------
// AUTHOR       : Jamie Collins
// DATE         : February 2002
//
//---------------------------------------------------------------------
// HISTORY
//
// DATE         PROGRAMMER        MODIFICATIONS
// February 2002  Jamie Collins    Initial version
//
//---------------------------------------------------------------------

#ifndef __SSL_H
#define __SSL_H

#define MAX_CIPHER_LIST 256

#define SSL_RETRY_NEEDED 0
#define SSL_ERROR        1

#define SSL_SERVER    TRUE
#define SSL_CLIENT    FALSE

#define SSL_CONTEXT_ANON		 1	/*init_ssl_context - set CTX for ADH	*/
#define SSL_CONTEXT_CERT		 2	/*init_ssl_context - set CTX for X.509	*/
#define SSL_CONTEXT_ANON_OR_CERT 3	/*init_ssl_context - set CTX for either */

typedef struct
{
  int socket;
  void * ssl;
  int interface_type;
}SSL_THREAD_DATA;

void SSL_Init( void );
int SSL_Init_ctx( void ** ctx, int context_type, int server, unsigned char * forceCipher );
void SSL_SetDsCertCallback( void * ctx, void * data) ;
void SSL_SetPreauthCertCallback( void * ctx, void * data) ;
void * SSL_Server_Handshake( void * ctx, int sockfd, int context_type );
void * SSL_Client_Handshake( void * ctx, int sockfd, int context_type );
void SSL_MultiThreadSetup ( void );
int SSL_Get_Error( void * ssl, int err );
int SSL_Write( void * ssl, unsigned char * buf, int len );
int SSL_vidwrite( void * ssl, unsigned char * buf, unsigned long physaddr, int len );
int SSL_Pending( void * ssl );
int SSL_Read( void * ssl, unsigned char * buf, int len );
int SSL_Shutdown( void * ssl );
void SSL_Free( void * ssl );
void SSL_ERR_Remove_State( void );
int SSL_Get_fd( void * ssl );
unsigned char * SSL_Get_cipher( void * ssl );
void * SSL_Get_peer_certificate( void * ssl );
void SSL_CTX_Free( void * ctx );
void X509_Free( void * X509_peer_cert );
int SSL_Get_Data(void * ssl, unsigned char *buf, unsigned long num, unsigned long timeout);
void SSL_Close_Connection(void * ssl);
void SSL_getCipherList( const DsmibEncrypTable *pEncrypTbl, char * cipherList, int context_type );
extern int SSL_vmread(void *s, unsigned char *buf, int chan, int len);

#endif //  __SSL_H
/* end */
