/************************************************************
 * Copyright (C) 1999 Cyclades Corporation					*
 * All Rights Reserved										*
 *															*
 * File        : cyccrc.h									*
 * Description : constants for crc generation				*
 * Author      : Elias Henrique Ferreira					*
 * Version     	 Date		Comments						*
 *															*
 *   1.0.0	 Mar/16/99	First Release						*
 ***********************************************************/

// CYCCRC EHF mar/99
#define CRC_FILE_ADDRESS			0x00002118UL
#define TOTAL_FILE_LEN_ADDRESS		0x00002114UL
#define	BINARY_FILE_HEADER_LEN		0x20
#define	FILE_LEN_OFFSET				0x14 // space for the old header 
#define	FILE_CRC_OFFSET				0x18
#define SIZE_OPCODE_OFFSET			0x10

#define OPCODE_ID_OFFSET			0x1A // Apr/24/00 Livio: Opcode ID

#define CRC_CHUNK	0x20000

typedef struct _CYCCRC {
	unsigned char	*pram;
	unsigned char	*pcrc;
	unsigned long	size;
	unsigned long	size_op;
	unsigned short	crc_read;
	unsigned short	crc_op;
	unsigned short	crc_calc;
} CYCCRC;

void crc_op_init(CYCCRC *pcyc, unsigned char *pbuf);

// Apr/24/00 Livio: Opcode ID
unsigned char calc_crc_cyros(CYCCRC *pcyc, unsigned long size);

