#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <errno.h>

unsigned long swab32(unsigned long x)
{
	return (((x & 0x000000ffU) << 24) |
			((x & 0x0000ff00U) <<  8) |
			((x & 0x00ff0000U) >>  8) |
			((x & 0xff000000U) >> 24));
}

#if __i386__
#define cpu_to_be32(x) swab32(x)
#else
#define cpu_to_be32(x) (x)
#endif

int main(int argc, char *argv[])
{
	int file;
	int argptr = 1;
	unsigned long image_address = 0, image_size = 0, file_size = 0;

	if ( argc != 4 )
	{
		fprintf(stderr, "usage: %s <image-address> <image-size> <zImage>\n",argv[0]);
		exit(-1);
	}

	image_address = strtoul(argv[1], NULL, 16);
	image_size = strtoul(argv[2], NULL, 16);
	file_size = cpu_to_be32(image_address + image_size - 0x10000);

	file = open(argv[3], O_RDWR);

	/* Seek to the program header file size field */
	lseek(file, 0x44, SEEK_SET);

	/* Write out new file size */
	write(file, &file_size, sizeof(file_size));

	return 0;
}
