#ifndef __BREAK
#define __BREAK
#include <linux/serialP.h>
#define PORT 0x3f8
#ifdef CONFIG_PORT
#undef PORT
#define PORT CONFIG_KGDB_PORT
#endif
#define IRQ 4
#ifdef CONFIG_IRQ
#undef IRQ
#define IRQ CONFIG_KGDB_IRQ
#endif
#define SB_CLOCK 1843200
#define SB_BASE (SB_CLOCK/16)
#define SB_BAUD9600 SB_BASE/9600
#define SB_BAUD192  SB_BASE/19200
#define SB_BAUD384  SB_BASE/38400
#define SB_BAUD576  SB_BASE/57600
#define SB_BAUD1152 SB_BASE/115200
#ifdef CONFIG_KGDB_9600BAUD
#define SB_BAUD SB_BAUD9600
#endif
#ifdef CONFIG_KGDB_19200BAUD
#define SB_BAUD SB_BAUD192
#endif
#ifdef CONFIG_KGDB_38400BAUD
#define SB_BAUD SB_BAUD384
#endif
#ifdef CONFIG_KGDB_57600BAUD
#define SB_BAUD SB_BAUD576
#endif
#ifdef CONFIG_KGDB_115200BAUD
#define SB_BAUD SB_BAUD1152
#endif
#ifndef SB_BAUD
#define SB_BAUD SB_BAUD1152        /* Start with this if not given*/
#endif
 
#define SB_IER 1
#define SB_MCR 0

#define FLAGS 0
#define SB_STATE {SSTATE_MAGIC,SB_BASE,PORT,IRQ,FLAGS,0,0,0,0,SB_BAUD}
#define SB_INFO  {SERIAL_MAGIC,PORT,0,FLAGS,0,&state,(struct tty_struct *)&state, \
0,0,0,0,0,0,0,0,SB_IER,SB_MCR}
extern void putDebugChar(int);
extern void kgdb_enable_ints(void);

#define INIT_KDEBUG putDebugChar("+");
/* This function is called by main.c just before cpu_idle.  It should
 * allow gdb to interrupt into the debug stub by sending a ^C.
 * What has to be done is to set up the serial chip, if not done yet, 
 * get an interrupt vector from the system and set it up to call the
 * stubs interrupt handler.  The handler will check for control C and
 * execute a breakpoint if it finds one.  Other chars should be stored
 * to some limit and provide when GetDebugChar asks for them.
 */

#define INIT_KGDB_INTS kgdb_enable_ints()

#ifndef BREAKPOINT   
#define BREAKPOINT   asm("   int $3");
/*
 * GDB debug stub (or any debug stub) can point the 'linux_debug_hook'
 * pointer to its routine and it will be entered as the first thing
 * when a trap occurs.
 *
 * Return values are, at present, undefined.
 *
 * The debug hook routines does not necessarily return to its caller.
 * It has the register image and thus may choose to resume execution
 * anywhere it pleases. 
 */
typedef int	gdb_debug_hook(int trapno,
			       int signo,
			       int err_code,
			       struct pt_regs *regs) ;
extern gdb_debug_hook	*linux_debug_hook ;
#endif
#endif /* __BREAK */

