/*
 * include/asm-ppc/cpc710.h
 * 
 * Definitions for the IBM CPC710 PCI Host Bridge
 *
 * Author: Matt Porter
 *         mporter@mvista.com
 *
 * Copyright 2000 MontaVista Software Inc.
 *
 * This program is free software; you can redistribute  it and/or modify it
 * under  the terms of  the GNU General  Public License as published by the
 * Free Software Foundation;  either version 2 of the  License, or (at your
 * option) any later version.
 *
 * THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR   IMPLIED
 * WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 * NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT,  INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 * USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * You should have received a copy of the  GNU General Public License along
 * with this program; if not, write  to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* General bridge and memory controller registers */
#define PIDR	0xff000008
#define	CNFR	0xff00000c
#define	RSTR	0xff000010
#define UCTL	0xff001000
#define	MPSR	0xff001010
#define	SIOC	0xff001020
#define	ABCNTL	0xff001030
#define SRST	0xff001040
#define	ERRC	0xff001050
#define	SESR	0xff001060
#define	SEAR	0xff001070
#define	PGCHP	0xff001100
#define	GPDIR	0xff001130
#define	ATAS	0xff001160
#define	AVDG	0xff001170
#define	MCCR	0xff001200
#define	MESR	0xff001220
#define	MEAR	0xff001230
#define	MCER0	0xff001300
#define	MCER1	0xff001310
#define	MCER2	0xff001320
#define	MCER3	0xff001330
#define	MCER4	0xff001340
#define	MCER5	0xff001350
#define	MCER6	0xff001360
#define	MCER7	0xff001370

/* System standard configuration registers space */
#define	DCR	0xff200000
#define	DID	0xff200004
#define	BAR	0xff200018

/* Device specific configuration space */
#define	PCIENB	0xff201000

/* Configuration space registers */
#define CPC710_BUS_NUMBER	0x40
#define CPC710_SUB_BUS_NUMBER	0x41
