/*-----------------------------------------------------------------------------
 *	Copyright (C) Cyclades Corporation, 1997.
 *	All rights reserved
 *
 *	TS1000 - RAS
 *
 *	This file:	cpld.h
 *	Description:	This file contains the definitions and prototypes 
 *			related to the CPLD programming
 *			
 *	
 *	Complies with Cyclades SW Coding Standard rev 1.2.
 *-----------------------------------------------------------------------------
 */
 
/*-----------------------------------------------------------------------------
 *	Change History
 *-----------------------------------------------------------------------------
 * Oct/25/2000	V 1.0.0		Edson Seabra
 *	Initial Implementation
 *
 *-----------------------------------------------------------------------------
 */

#define DB_UART_ADDR_SIZE		0x1000
#define DB_CPLD_ADDR_SIZE		0x1000
 
/* CPLD registers */ 
typedef struct _cpld_regs {
	unsigned char reset_enable1;
	unsigned char clock_enable1;
	unsigned char clock_source1;
	unsigned char cpld_misc;
	unsigned char intr_enable1;
	unsigned char intr_enable2;
	unsigned char intr_enable3;
	unsigned char intr_enable4;
	unsigned char intr_status1;
	unsigned char intr_status2;
	unsigned char intr_status3;
	unsigned char intr_status4;
	unsigned char fpga_id;
	unsigned char reserve1[3];
	unsigned char reset_enable2;
	unsigned char clock_enable2;
	unsigned char clock_source2;
	unsigned char reserve2;
	unsigned char intr_enable5;
	unsigned char intr_enable6;
	unsigned char reserve3[2];
	unsigned char intr_status5;
	unsigned char intr_status6;
	unsigned char reserve4[6];
	unsigned char bsmux;
	unsigned char reserve5[6];
	unsigned char id_cpld;
} cpld_regs;

/* Serial Expander UART registers */
typedef union 
{
	struct uart_read  {
		unsigned char	rhr;
		unsigned char	space;
		unsigned char	isr;		// SSE8-V174
		unsigned char	lcr;
		unsigned char	mcr;
		unsigned char	lsr;
		unsigned char	msr;
		unsigned char	spr;
	} r;
											
	struct uart_write  {
		unsigned char	thr;
		unsigned char	ier;
		unsigned char	fcr;
		unsigned char	lcr;
		unsigned char	mcr;
		unsigned char	space[2];
		unsigned char	spr;
    } w;
	
	struct uart_special {
		unsigned char	dll;
		unsigned char	dlm;
		unsigned char	efr;
		unsigned char	space;
		unsigned char	xon1;
		unsigned char	xon2;
		unsigned char	xoff1;
		unsigned char	xoff2;
	} s;
} UART_REGS;

extern volatile cpld_regs *cpld;

extern volatile void	*uarts;

