/*------------------------------------------------------------------------
 *  Copyright (C) Cyclades Corporation, 1998.
 *  All rights reserved
 *  PR-3000 TS
 *
 *  This file:      cy_zbus.h
 *  Description:    This file contains the definitions and prototypes
 *                  related to the ZBUS programming
 *-----------------------------------------------------------------------*/

/*-------------------------------------------------------------------------
 *  Change History
 *-------------------------------------------------------------------------
 *  Aug/30/2000    V 1.0.0 Edson Ap. Seabra - Initial Implementation
 *------------------------------------------------------------------------*/

#define ZBUS_FW_VERSION     100

#define MAX_SEXS_PER_SLOT   4
#define MAX_PORTS_PER_SEX   16

#define Z_ENABLE_INTERNAL_POWER     0x01
#define Z_DISABLE_INTERNAL_POWER    0x00
#define Z_EXTERNAL_POWER_ACTIVE     0x01
#define Z_NO_EXTERNAL_POWER         0x00

#define     ZBUS_UART_CLOCK     14745600L
#define     UART_FIFO_SIZE      64
#define     TX_FIFO_LEVEL       8
#define     UART_FREE_SIZE      UART_FIFO_SIZE - TX_FIFO_LEVEL  //56

#define     IER_CLEAR       0x00
#define     MCR_CLEAR       0x00
#define     MCR_LLOOPBACK       (1<<4)
#define     MCR_CLOCK_SELECT    (1<<7)
#define     LSR_RECEIVE_DATA_READY      1
#define     LCR_DLAB            (1<<7)
#define     LCR_EFR_ENABLE      0xBF


typedef struct {
	unsigned long	fw_version;		// Firmware Version
	unsigned char	*base_address;	// Board address
	unsigned char	nirq;			// IRQ line to Processor MMC860
	unsigned char	nsex;			// Number of SEX's on the slot
	unsigned char	power;			// Power Supply at boot.
	unsigned char	status_flag;
	unsigned short	first_tty;
	unsigned short	last_tty;
} ZBUS_INFO;

