/* -*- linux-c -*- */
/*
    This file is part of llconf2

    Copyright (C) 2004  Oliver Kurth <oku@debian.org>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* copied from llconf, modified, and will hopefully be returned to llconf sometime
   to avoid duplication... */

#ifndef _LINES_H_INCLUDED
#define _LINES_H_INCLUDED

#define MAX_LINE 4096

struct line
{
  struct line *next;
  char *line;
};

struct line *create_line(const char *line);
void destroy_line(struct line *l);
void destroy_line_list(struct line *l_list);
struct line *append_line(struct line *l_list, struct line *l);
struct line *prepend_line(struct line *l_list, struct line *l);

int line_setval(struct line *l, const char *value);

struct line *read_lines(FILE *fptr);
struct line *convert_lines(const char *buf, int size);

#endif /* _LINES_H_INCLUDED */
