/* -*- linux-c -*- */
/*
    This file is part of cacpd

    Copyright (C) 2005 Cyclades Corp.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/* Author: Oliver Kurth <oliver.kurth@cyclades.com> */

#ifndef _LOOP_H_INCLUDED
#define _LOOP_H_INCLUDED

struct fd_callback
{
	struct fd_callback *next;
	int type;
	int state;
	int fd;
	int (*cb)(int, void *);
	void *data;
};

/* type: */
#define FDCB_READ 1
#define FDCB_WRITE 2

/* state: */
#define FDCB_CLOSING 1

extern struct fd_callback *g_cb_list;
extern struct fd_callback *g_timecb_list;

void loop_prepend_callback(struct fd_callback *cb);
void loop_add_callback(struct fd_callback *cb);
void loop_del_callback(struct fd_callback *cb);
struct fd_callback *create_fd_callback(int fd, int type, int (*f)(int, void *), void *data);
void loop(struct timeval *timeout);

#endif /* _LOOP_H_INCLUDED */
