/* -*- linux-c -*- */
/*
    This file is part of cacpd

    Copyright (C) 2005 Cyclades Corp.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/* Author: Oliver Kurth <oliver.kurth@cyclades.com> */

#include "slist.h"

struct slist_hdr *slist_append(struct slist_hdr *first, struct slist_hdr *new)
{
	struct slist_hdr **p;
	
	for(p = &first; *p; p = &((*p)->next));
	*p = new;
	return first;
}

struct slist_hdr *slist_prepend(struct slist_hdr *first, struct slist_hdr *new)
{
	new->next = first;
	return new;
}

struct slist_hdr *slist_unlink(struct slist_hdr *first, struct slist_hdr *item)
{
	struct slist_hdr **p;

	for(p = &first; *p && (*p != item); p = &((*p)->next));
	if(*p)
		*p = (*p)->next;
	return first;
}
