#include <stdio.h>
#include <stdlib.h>
#include <termios.h>
#include <time.h>
#include <signal.h>
#include <ctype.h>
#include <errno.h>
#include <arpa/inet.h>
#include <fcntl.h>
#include <grp.h>
#include <netdb.h>
#include <netinet/in.h>
#include <pwd.h>
#include <string.h>
#include <sys/resource.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/types.h>
#include <syslog.h>
#include <unistd.h>
#include <utmp.h>
#include <crypt.h>
#include <string.h>

#include "server.h"

static int get_group(char *user, char *grp);

int check_users_access(char *users, char *user, int null_valid)
{
    char *p, ch[32];
    int  deny_access;

    if (users == NULL  || *users == 0) {
        return(null_valid);
    }

    deny_access = strchr(users, '!') ? 1 : 0;

    for (p=ch; users; users++) {
        switch(*users) {
        case 0:
            users = (char *)-1;
            /* fall through */
        case '!':
        case ',':
        case ' ':
        case '\t':
            if (p != ch) {
                *p = 0;
                if (!strcmp(ch, user))
                    return(deny_access);
    			if (get_group(user, ch))
                    return(deny_access);
                p = ch;
            }
            break;
        default:
            *p++ = *users;
            break;
        }
    }

    // user not found only accept if users should be denied
    return(!deny_access);
}

static int get_group(char *user, char *grp)
{
    char *group, *p, *u, usr[32];

    group = mainconf.groups;

    while (group) {
        p = group+4;
        u = usr;
        for ( ; p; p++) {
            switch(*p) {
            case 0:
				p = (char *)-1;
                /* fall through */
            case ',':
            case ' ':
            case '\t':
                if (u != usr) {
                    *u = 0;
                    if (!strcmp(usr, user)) return(1);
                    u = usr;
                }
				if (p == (char *)-1) return(0);
                break;
            case ':':
                *u = 0;
				if (strcmp(usr, grp)) {
					p = (char *)-1;
				}
                u = usr;
                break;
            default:
                *u++ = *p;
                break;
            }
        }
        group = *(char **)group;
    }
    return(0);
}

