#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>
#include <termios.h>
#include <signal.h>
#include <ctype.h>
#include <errno.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/mount.h>
#include <sys/wait.h>

#define XDEBUG	0

#include "server.h"

static int exec_cmd(char *buffer, int size)
{
	char *p = buffer;
	char *s;
	int cnt;

	while ((s = strstr(p, " ;; ")) != NULL) {
		*s = 0;
		XPRINTF4("cy_alarm: exec cmd [%s]\r\n", p);
		system(p);
		p = s + 4;
	}

	cnt = p - buffer;

	if (cnt < size) {
		size -= cnt;
		strncpy(buffer, p, size);
	} else {
		size = 0;
	}

	return size;
}

int main(int argc, char **argv)
{
	/* Input fd set */
	fd_set InFdSet;
	int pipe_fd, cnt, tot_cnt=0;
	unsigned char buffer[1024];
	struct timeval tv;

	/* Redirect stdin, stdout, and stderr to /dev/null. */
	freopen("/dev/null", "r", stdin);
	freopen("/dev/null", "w", stdout);
	freopen("/dev/null", "w", stderr);

	if (argc >= 2) {
		set_xprintf(atoi(argv[1]));
	}

	pipe_fd = open("/dev/cyc_alarm",O_RDWR | O_NONBLOCK | O_NOCTTY | O_LARGEFILE);

	if (pipe_fd == -1) {
		exit;
	}

	while (1) {

		FD_ZERO(&InFdSet);
		FD_SET(pipe_fd,&InFdSet);

		tv.tv_sec = 3;	// 3 sec
		tv.tv_usec = 0;

		if ((cnt=select(pipe_fd+1,&InFdSet,NULL, NULL, &tv)) <= 0) {
			if (cnt < 0) {
				XPRINTF4("cy_alarm : select error\r\n");
			}
			continue;
		}

		if (!FD_ISSET(pipe_fd,&InFdSet))  continue;

		cnt = read(pipe_fd, &buffer[tot_cnt], sizeof(buffer) -1 - tot_cnt);
		if (cnt > 0) {
			tot_cnt += cnt;
			buffer[tot_cnt] = 0x00;
			XPRINTF8("cy_alarm: received data **[%s]**\r\n",&buffer[tot_cnt-cnt]);
			tot_cnt = exec_cmd(buffer, tot_cnt);
		}
	}

	return(0);
}
