#include <syslog.h>

#define P_IDLE  0
#define P_INCOM 5
#define P_LOGIN 10

#define TELNET_PORT	23

/* Range of normal, non escape ascii chars */
#define Fascii	32	//Space
#define Lascii	126	//Tilde

/* Some syntatic sugar */
#define TRUE	1
#define FALSE	0
#define noerror  0

/*
 * Global functions for the portslave.
 */
// lib.c
void title(int all, char **argv, char *fmt, ...);
void block(int sig);
void unblock(int sig);
char *dotted(unsigned int a);
void expand_format(char *buffer, size_t size, char *format, struct auth *ai);
void set_remote_address(int s, struct auth *ai);

// getty.c
int HandleChar(int SockFd, int PortFd, char C);
void crtrans(int fd, int inon, int outon) ;
void disass_ctty();
int getty(struct auth *ai, int location,struct termios *old_tio);

int chat(int fd, char *str, struct auth *ai);
int do_login1(struct auth *ai);
int spawnit(struct auth *ai);
int do_slip(struct auth *ai);

int update_utmp(char *login_fmt, char *from_fmt, struct auth *ai, int wtmp);
void tstr(int sending, char *s);
char *term_in_use(struct line_cfg *lc, int location);

// rot_getty.c
int serial_open(struct line_cfg *pconf, int location, struct termios *old_tio);
void serial_close(int fd, struct termios *old_tio);
int get_baud_table_index(int BaudRate);
int get_baud_table_speed(int Speed);
void maketermsane(int fd);
char *get_tty_text(struct line_cfg *lc);
void makeRawOrStty(int devFd, struct line_cfg *pconf);
