/*****************************************************************
File: sh_write_event.c

Description: -- write event message to /var/run/snmp_pipe fifo 
device.

The purpose of creating this program is so that you can write 
event messages from a shell script. The messages are outputted 
to the /var/run/snmp_pipe fifo device instead of the standard 
output. 
This program basically takes in two parameters :
- event number
- the text to be logged. 
****************************************************************/

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/file.h>
#include <sys/signal.h>
#include <sys/uio.h>
#include <sys/wait.h>
#include <netdb.h>
#include <netinet/in.h>
#include <string.h>
#include <time.h>
#include <unistd.h>
#include <errno.h>
#include <stdarg.h>
#include <paths.h>
#include <stdio.h>

void writeevt(int,char*,...);

int main (int argc, char *argv[])
{
	int eventn,cnt;
	char *fmt;
	union {
		char * pars;
		int    pard;
	} param[6];

	eventn = atoi(argv[1]);

	fmt = argv[2];

	cnt = 0;

	memset((char *) param,0, 24);

	while (*fmt) {
		if (*fmt == 'u') {
			fmt++;
			continue;
		}
		if (*fmt == 'i') {
			param[cnt].pard = atoi(argv[cnt+3]); //integer	
		} else {
			param[cnt].pars = argv[cnt+3];
		}
		cnt++; fmt++;
	}	

	writeevt(eventn,argv[2],param[0].pard,param[1].pard,param[2].pard,param[3].pard,
		param[4].pard, param[5].pard);

	return 0;
}

