#ifndef CYPM_H
#define CYPM_H

#define CY_ID_SHM 0xFACBADEC
#define CY_ADDR_SHM     0x3FF00000
#define SHM_PERM	0666

#define PROD_OID        1,3,6,1,4,1,2925,4
#define PROD_OID_SIZE   8


/* shared memory struct - copy from RAS_DIR/src/cy_shm.h */
struct CY_SHM_SNMP {
	int	id_shm;
	int	sem_id;
	int	max_dev;
	int	st_cy_ras;
	int	DB_pid;
	int	DB_pid_poll;
	int	DB_status;
	char	DB_path[32];
	int	PMD_pid;        // This is the PMD server pid
	int	PMD_outlets[48]; // number of outlets in the serial port
	int	PMD_pms[48]; // number of PMs in the serial port
};

/*
 * function declarations 
 */
void init_cyPM(void);

unsigned char *var_cyNumberOfPM(struct variable *vp, oid * name, size_t * length,
		 int exact, size_t * var_len, WriteMethod ** write_method);

unsigned char *var_cyPMTable(struct variable *vp, oid * name, size_t * length,
		 int exact, size_t * var_len, WriteMethod ** write_method);

unsigned char *var_cyPMUnitTable(struct variable *vp, oid * name, 
	size_t * length, int exact, size_t * var_len, 
	WriteMethod ** write_method);

unsigned char *var_cyOutletTable(struct variable *vp, oid * name, 
	size_t * length, int exact, size_t * var_len, 
	WriteMethod ** write_method);

int write_cyPM_command(int action, u_char * var_val, u_char var_val_type,
	   size_t var_val_len, u_char * statP, oid * name, size_t name_len);

int write_cyOutlet_name(int action, u_char * var_val, u_char var_val_type,
	size_t var_val_len, u_char * statP, oid * name, size_t name_len);
int write_cyOutlet_lock(int action, u_char * var_val, u_char var_val_type,
   size_t var_val_len, u_char * statP, oid * name, size_t name_len);
int write_cyOutlet_power(int action, u_char * var_val, u_char var_val_type,
   size_t var_val_len, u_char * statP, oid * name, size_t name_len);
int write_cyOutlet_interval(int action, u_char * var_val, u_char var_val_type,
   size_t var_val_len, u_char * statP, oid * name, size_t name_len);

int write_cyPMUnit_current(int action, u_char * var_val, u_char var_val_type,
      size_t var_val_len, u_char * statP, oid * name, size_t name_len);
int write_cyPMUnit_temp(int action, u_char * var_val, u_char var_val_type,
      size_t var_val_len, u_char * statP, oid * name, size_t name_len);


#endif	/* CYPM_H */
