/*
 * appl4.c -- Routines for the web pages (LINUX version)
 *
 */

/******************************** Description *********************************/

/*
 *	Routines for the web pages (asp/form/cgi)
 *	This module manages the web pages for administration tools.
 */

/********************************* Includes ***********************************/

#include	"appl.h"
#include	<signal.h>
#include	<unistd.h>
#include	<sys/types.h>
#include	<sys/wait.h>
#include	<dirent.h>
#include        <src/server.h>
#include        <ipdu.h>

#if 0
static int PrintSerialPort(int eid, webs_t wp, int argc, char_t **argv)
{
    int i;
    websWrite(wp, T("<select name=\"port\">"));
    for (i=1; i<=numsports; i++) {
        websWrite(wp, T("<option value=\"%d\">Port %d"), i, i);
    }
    websWrite(wp, T("</select>"));
    return 0;
}


static unsigned char *speedlist[] = {
"50", "75", "110", "134", "150", "200", "300", "600", "1200", "1800",
"2400", "4800", "9600", "14400", "19200", "28800", "38400", "57600", 
"76800", "115200", "230400", "460800"};

static int PrintSpeed(int eid, webs_t wp, int argc, char_t **argv)
{
	int i;
	websWrite(wp, "<select name=\"speed\">");
	for (i=0; i<22; i++) {
		websWrite(wp, "<option value=\"%s\"%s>%s",
			speedlist[i], (i==12)?" selected":"", speedlist[i]);
	}
	websWrite(wp, "</select>");
	return 0;
}

static char CountLines(char *buffer)
{
	char i, *s;
	for (i=0, s=buffer; *s; s++) if (*s == '\n') i++;
	return i;
}

static char *RemoveLines(char *buffer, char nlines)
{
	char i, *s;
	for (i=0, s=buffer; *s && i<nlines; s++) if (*s == '\n') i++;
	return s;
}

#define PORTCONV_MAX_LINES	15
#define PORTCONV_BUFSIZE	1024
static void PortConv(webs_t wp, char_t *path, char_t *query)
{
	char ttyname[32], aux[PORTCONV_BUFSIZE];
	int fd, i;
	int ch;
	char *bufout, *comm, *opt, *addout = aux, *s, *t;
	char ntotlines;
	int nbytesrd;
	struct cyc_webs_header hdr;
	if (websGetVar(wp, T("init"), NULL)) {
		sprintf (ttyname, "/dev/ttyS%s", websGetVar(wp, T("port"), ""));
		sprintf (aux, "stty -F %s %s -echo -onlcr -icrnl -icanon min "
			"0 time 1", ttyname, websGetVar(wp, T("speed"), ""));
		system(aux);
		fd = open(ttyname, O_RDWR | O_NONBLOCK);
	} else {
		if (!sscanf(websGetVar(wp, T("port"), ""), "%d", &fd)) fd=-1;
		opt = websGetVar(wp, T("opt"), "");
		if (*opt=='Q') {
			close(fd);
			websRedirect(wp, "/adm/portconv.asp", NULL);
			return;
		}
		strcpy(aux, websGetVar(wp, T("comm"), ""));
		s = aux + strlen(aux);
		if (websGetVar(wp, T("cret"), NULL)) {
			*s++=13;
		}
		if (websGetVar(wp, T("newl"), NULL)) {
			*s++=10;
		}
		if (websGetVar(wp, T("escp"), NULL)) {
			*s++=11;
		}
		if (!(comm = websGetVar(wp, T("char"), NULL)) && sscanf(comm, "%d", &ch)) {
			*s++=ch;
		}
		*s=0;
		if (write(fd, aux, s-aux) == -1) {
			perror("Port Conversation");
		};
	}
	bufout = websGetVar(wp, T("bufout"), "");
	
	t = addout+PORTCONV_BUFSIZE-1;
	*t = 0;
	s = addout;
	*s = 0;
	sleep(1);
	while (1) {
		nbytesrd = read(fd, s, addout+PORTCONV_BUFSIZE-1-s);
		if (nbytesrd <= 0 || nbytesrd > addout+PORTCONV_BUFSIZE-1-s) break;
		s+=nbytesrd;
		if (t<s+1) {
			if (s==addout+PORTCONV_BUFSIZE-1) s=addout;
			t=s+1;
		}
		*s=0;
	}
	ntotlines = CountLines(t);
	if (ntotlines > PORTCONV_MAX_LINES) {
		t = RemoveLines(t, ntotlines - PORTCONV_MAX_LINES);
		*addout=0;
		bufout+=strlen(bufout);
	} else {
		ntotlines+= CountLines(addout);
		if (ntotlines > PORTCONV_MAX_LINES) {
			addout = RemoveLines(addout, ntotlines - PORTCONV_MAX_LINES);
			bufout+=strlen(bufout);
		} else {
			ntotlines+= CountLines(bufout);
			if (ntotlines > PORTCONV_MAX_LINES) {
				bufout = RemoveLines(bufout, ntotlines - PORTCONV_MAX_LINES);
			}
		}
	}
	if (ntotlines > PORTCONV_MAX_LINES) ntotlines = PORTCONV_MAX_LINES;
	for (i=0; i<PORTCONV_MAX_LINES-ntotlines; i++) ttyname[i]='\n';
	ttyname[PORTCONV_MAX_LINES-ntotlines] = 0;
        websCycHdrInit(&hdr);
	hdr.need_header = 1;
        hdr.title = "Port Conversation";
	hdr.father = "/adm/portconv.asp";
	if (fd == -1) {
	        websPageMessage(wp, &hdr, "Error - Invalid File Descriptor.");
	} else {
	        hdr.form = "adm/PortConv";
		websPageStart(wp, &hdr);
		websWrite(wp, "<input type=\"hidden\" name=\"port\" value=\"%d\">", fd);
		websWrite(wp, "<input type=\"hidden\" name=\"bufout\" value=\"%s%s%s\">",
			bufout, t, addout);
		websWrite(wp, "<center><table border align=\"center\">");
		websWrite(wp, "<tr><th class=\"tt\" colspan=\"4\">Output</th></tr>");
		websWrite(wp, "<tr><td colspan=\"4\"><pre>%s%s%s%s</pre></td></tr>", bufout, t, addout, ttyname);
		websWrite(wp, "<tr><th class=\"tt\" colspan=\"4\">Input</th></tr>");
		websWrite(wp, "<tr><td colspan=\"4\"><input class=\"tx\" type=\"text\" name=\"comm\" size=\"80\"></td></tr>");
		websWrite(wp, "<tr>");
		websWrite(wp, "<td><input type=\"checkbox\" name=\"newl\"><b> Insert LF</b></td>");
		websWrite(wp, "<td><input type=\"checkbox\" name=\"cret\" checked><b> Insert CR</b></td>");
		websWrite(wp, "<td><input type=\"checkbox\" name=\"escp\"><b> Insert ESC</b></td>");
		websWrite(wp, "<td><b>Insert Character: </b><input class=\"tx\" type=\"text\" name=\"char\" size=\"3\"></td>");
		websWrite(wp, "</tr></table></center>");
		websWrite(wp, "<br><center><input type=\"submit\" name=\"opt\" value=\"Enter\">");
		websWrite(wp, "&nbsp;&nbsp;&nbsp;&nbsp;<input type=\"submit\" name=\"opt\" value=\"Quit\"></center>");
		websPageEnd(wp, &hdr);
	}
}
#endif

static int PrintGroupSys(int eid, webs_t wp, int argc, char_t **argv)
{
    int i;
    FILE *arq;
    unsigned char buf[512];
    unsigned char *paux;

    arq = fopen("/etc/group","r");

    websWrite(wp, T("<select name=\"group1\">"));
    
    websWrite(wp, T("<option value=default>default"));
    while (fgets(buf,512,arq)) {
    	paux = strchr(buf,':');
	*paux = 0x00;
        websWrite(wp, T("<option value=\"%s\">%s"),buf,buf);
    }
    fclose(arq);
    websWrite(wp, T("</select>"));
    return 0;
}

static void RebootConfirm(webs_t wp, char_t *path, char_t *query)
{
	unsigned char *reboot = websGetVar(wp, T("reboot"), NULL);
	unsigned char *message, error;
	struct cyc_webs_header hdr;
	
	websCycHdrInit(&hdr);
	hdr.title = "Reboot";
	hdr.father = "/adm/reboot.asp";

	if (reboot && *reboot=='1') {
		hdr.cookie = "sessionId=deleted; path=/; "
			"expires=Wed, 15-Aug-2001 12:00:00 GMT";
		hdr.refresh_secs = 180;
		hdr.refresh_url = "/home.asp";
		websPageMessage(wp, &hdr, "The System is going to be halted. "
			"This will take some minutes...", 1);

	} else {
		websPageMessage(wp, &hdr, "The reboot process was canceled.", 
			0);
	}
	
	if (reboot && *reboot=='1') {
		system("reboot"); //[RK]Aug/18/06 - halt command was removed
	}
}

unsigned char *namemonths[] = {"Jan", "Feb", "Mar", "Apr", "May", "Jun",
							   "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};
static int PrintDateOpt(int eid, webs_t wp, int argc, char_t **argv)
{
	time_t tm;
	struct tm tm_time;
	int i;
	time(&tm);
	memcpy(&tm_time, localtime(&tm), sizeof(tm_time));
	/* Month */
	websWrite(wp, T("<td><center><select name=\"month\">"));
	for (i=0; i<12; i++) {
		websWrite(wp, T("<option value=\"%d\""), i+1);
		if (i==tm_time.tm_mon) {
			websWrite(wp, T(" selected"));
		}
		websWrite(wp, T(">%s"), namemonths[i]);
	}
	websWrite(wp, T("</select></center></td>"));

	/* Day */
	websWrite(wp, T("<td><center><select name=\"day\">"));
	for (i=1; i<=31; i++) {
		websWrite(wp, T("<option value=\"%d\""), i);
		if (i==tm_time.tm_mday) {
			websWrite(wp, T(" selected"));
		}
		websWrite(wp, T(">%02d"), i);
	}
	websWrite(wp, T("</select></center></td>"));
	
	/* Year */
	websWrite(wp, T("<td><center><select name=\"year\">"));
	for (i=2000; i<=2030; i++) {
		websWrite(wp, T("<option value=\"%d\""), i);
		if (i==tm_time.tm_year+1900) {
			websWrite(wp, T(" selected"));
		}
		websWrite(wp, T(">%d"), i);
	}
	websWrite(wp, T("</select></center></td>"));
	return 0;
}

static int PrintTimeOpt(int eid, webs_t wp, int argc, char_t **argv)
{
	time_t tm;
	struct tm tm_time;
	int i;
	time(&tm);
	memcpy(&tm_time, localtime(&tm), sizeof(tm_time));
	/* Hour */
	websWrite(wp, T("<td><center><select name=\"hour\">"));
	for (i=0; i<24; i++) {
		websWrite(wp, T("<option value=\"%d\""), i);
		if (i==tm_time.tm_hour) {
			websWrite(wp, T(" selected"));
		}
		websWrite(wp, T(">%2d"), i);
	}
	websWrite(wp, T("</select></center></td>"));
	
	/* Minute */
	websWrite(wp, T("<td><center><select name=\"minute\">"));
	for (i=0; i<60; i++) {
		websWrite(wp, T("<option value=\"%d\""), i);
		if (i==tm_time.tm_min) {
			websWrite(wp, T(" selected"));
		}
		websWrite(wp, T(">%02d"), i);
	}
	websWrite(wp, T("</select></center></td>"));

	/* Year */
	websWrite(wp, T("<td><center><select name=\"second\">"));
	for (i=0; i<60; i++) {
		websWrite(wp, T("<option value=\"%d\""), i);
		if (i==tm_time.tm_sec) {
			websWrite(wp, T(" selected"));
		}
		websWrite(wp, T(">%02d"), i);
	}
	websWrite(wp, T("</select></center></td>"));
	return 0;
}


static void SetDate(webs_t wp, char_t *path, char_t *query)
{
	FILE *arq;
	unsigned char buffer[256];
	unsigned char ndays[] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
	unsigned char *var;
	unsigned int day, month = 1, year, hour, minute, second;
	unsigned char err = 0;
	struct cyc_webs_header hdr;
	var = websGetVar(wp, T("year"), "");
	if (!sscanf(var, "%d", &year)) err|=4;
	if (year < 100) {
		if (year < 70)
			year+=2000;
		else
			year+=1900;
	}
	if (year%4) ndays[1]=29;
	var = websGetVar(wp, T("month"), "");
	if (!sscanf(var, "%d", &month) || month<1 || month>12) err|=2;
	var = websGetVar(wp, T("day"), "");
	if (!sscanf(var, "%d", &day) || day<1 || day>ndays[month-1]) err|=1;
	var = websGetVar(wp, T("hour"), "");
	if (!sscanf(var, "%d", &hour) || hour<0 || hour>23) err|=8;
	var = websGetVar(wp, T("minute"), "");
	if (!sscanf(var, "%d", &minute) || minute<0 || minute>60) err|=16;
	var = websGetVar(wp, T("second"), "");
	if (!sscanf(var, "%d", &second) || second<0 || second>60) err|=32;
	
	if (err) {
		sprintf (buffer, "Invalid Date/Time!<br>The following fields are wrong:%s%s%s%s%s%s",
			(err &  1)?" day":"",  (err &  2)?" month":"",   (err &  4)?" year":"",
			(err &  8)?" hour":"", (err &  16)?" minute":"", (err &  32)?" second":"");
	} else {
		sprintf(buffer, "date %02d%02d%02d%02d%04d.%02d>/tmp/webtemp",
			month, day, hour, minute, year, second);
		system(buffer);
		strcpy(buffer, "Current Date/Time is ");
		arq = fopen("/tmp/webtemp", "r");
		fgets(buffer+strlen(buffer), 256-strlen(buffer), arq);
		fclose(arq);
		system("rm -f /tmp/webtemp");
	}
	websCycHdrInit(&hdr);
	hdr.title = "Set Date/Time";
	hdr.father = "/adm/datetime.asp";
	websPageMessage(wp, &hdr, buffer, err);
}

static void LinkToEditTextFile(webs_t wp, char_t *path, char_t *query)
{
  FILE *arq;
  struct stat st;
  unsigned char buffer[2];
  unsigned char temp[100]={0};
  unsigned char *filename = websGetVar(wp, T("filename"), "");
  int size, size2, ch, bfile=0;
  struct cyc_webs_header hdr;
  websCycHdrInit(&hdr);
  hdr.need_header = 1;
  hdr.title = "Edit Text File";
  hdr.form = "cfg/WriteTextFile";
  sprintf(temp, "/goform/LinkToEditTextFile?filename=%s", filename);
  hdr.father = temp;
  websPageStart(wp, &hdr);

  if (stat(filename, &st)) {
    websWrite(wp, T("<center><b class=\"err\">Warning! This File does not exist.</b></center>"));
    size=0;
  } else {
    if (st.st_size > 32*1024) {
      websWrite(wp, T("<center><b class=\"err\">Warning! This file is greater than 32 Kbytes. It will be truncated.</b></center>"));
      size = 32*1024;
    } else {
      size = st.st_size;
    }
  }
  websWrite(wp, "<input type=\"hidden\" name=\"link\" value=\"%s\">", temp);
  websWrite(wp, "<input type=\"hidden\" name=\"filename\" value=\"%s\">", filename);
  websWrite(wp, "<center><table border align=\"center\">"
    "<tr><th class=\"tt\">Edit File %s</th></tr>", filename);
  websWrite(wp, "<tr><td><textarea class=\"ed\" name=\"filetext\" "
    "rows=\"20\" cols=\"80\" wrap=\"off\"%s>",
    (websGetPriority(wp) == PRIV_FULL)?"":" readonly");
  if (size) {
    arq = fopen(filename, "r");
                if (arq) {
      websWriteTextFile(wp, arq, 0, &bfile);
      fclose(arq);
    }
  }
  websWrite(wp, "</textarea></td></tr></table></center>");
  if (bfile) {
    websWrite(wp, T("<center><b class=\"err\">Warning! This is not a text file. Some of the characters were omitted.</b></center>"));
  }
	 if (websGetPriority(wp) == PRIV_FULL) {
		websWrite(wp, "<p>&nbsp;</p><p align=\"center\"><b>For security purposes, please enter your username and 
			  password, and then press Submit.</b></p>");
		websWrite(wp, "<center><table BORDER align=\"center\">"
			"<tr><td><b>User Name:</b></td><td><input class=\"tx\" type=\"text\" name=\"username1\"></td></tr>"
			"<tr><td><b>Password:</b></td><td><input class=\"tx\" type=\"password\" name=\"passwd1\"></td></tr>"
			"<tr><td><b>Repeat Password:</b></td><td><input class=\"tx\" type=\"password\" name=\"passwd2\"></td></tr>"
			"</table></center>");
		 websWrite(wp, "<br><center><input type=\"submit\" value=\"Submit\">&nbsp;&nbsp;&nbsp;&nbsp;");
		 websWrite(wp, "<input type=\"reset\" value=\"Reset\"></center>");
  }
  websPageEnd(wp, &hdr);
}

static void EditTextFile(webs_t wp, char_t *path, char_t *query)
{
	FILE *arq;
	struct stat st;
	unsigned char buffer[2];
	unsigned char *filename = websGetVar(wp, T("filename"), "");
	int size, size2, ch, bfile=0;
	struct cyc_webs_header hdr;
	websCycHdrInit(&hdr);
	hdr.need_header = 1;
	hdr.title = "Edit Text File";
	hdr.form = "cfg/WriteTextFile";
	hdr.father = "/read/editfile.asp";
	websPageStart(wp, &hdr);
		
	if (stat(filename, &st)) {
		websWrite(wp, T("<center><b class=\"err\">Warning! This File does not exist.</b></center>"));
		size=0;
	} else {
		if (st.st_size > 32*1024) {
			websWrite(wp, T("<center><b class=\"err\">Warning! This file is greater than 32 Kbytes. It will be truncated.</b></center>"));
			size = 32*1024;
		} else {
			size = st.st_size;
		}
	}
	websWrite(wp, "<input type=\"hidden\" name=\"filename\" value=\"%s\">", filename);
	websWrite(wp, "<center><table border align=\"center\">"
		"<tr><th class=\"tt\">Edit File %s</th></tr>", filename);
	websWrite(wp, "<tr><td><textarea class=\"ed\" name=\"filetext\" "
		"rows=\"20\" cols=\"80\" wrap=\"off\"%s>", 
		(websGetPriority(wp) == PRIV_FULL)?"":" readonly");
	if (size) {
		arq = fopen(filename, "r");
                if (arq) {
			websWriteTextFile(wp, arq, 0, &bfile);
			fclose(arq);
		}
	}
	websWrite(wp, "</textarea></td></tr></table></center>");
	if (bfile) {
		websWrite(wp, T("<center><b class=\"err\">Warning! This is not a text file. Some of the characters were omitted.</b></center>"));
	}

	if (websGetPriority(wp) == PRIV_FULL) {
		websWrite(wp, "<p>&nbsp;</p><p align=\"center\"><b>For security purposes, please enter your username and 
			  password, and then press Submit.</b></p>");
		websWrite(wp, "<center><table BORDER align=\"center\">"
			"<tr><td><b>User Name:</b></td><td><input class=\"tx\" type=\"text\" name=\"username1\"></td></tr>"
			"<tr><td><b>Password:</b></td><td><input class=\"tx\" type=\"password\" name=\"passwd1\"></td></tr>"
			"<tr><td><b>Repeat Password:</b></td><td><input class=\"tx\" type=\"password\" name=\"passwd2\"></td></tr>"
			"</table></center>");
		websWrite(wp, "<br><center><input type=\"submit\" value=\"Submit\">&nbsp;&nbsp;&nbsp;&nbsp;");
		websWrite(wp, "<input type=\"reset\" value=\"Reset\"></center>");
	}
	websPageEnd(wp, &hdr);
}

static void WriteTextFile(webs_t wp, char_t *path, char_t *query)
{
	FILE *arq;
	unsigned char *link = websGetVar(wp, T("link"), "");
	unsigned char *filename = websGetVar(wp, T("filename"), "");
	unsigned char *filetext = websGetVar(wp, T("filetext"), "");
	unsigned char *userid = websGetVar(wp, T("username1"), "");
	unsigned char *var = websGetVar(wp, T("passwd1"), "");
	unsigned char *var2 = websGetVar(wp, T("passwd2"), "");
	unsigned char *s, *t, *userpass;
	unsigned char error=1, *message, header[128];
	struct cyc_webs_header hdr;
	char_t *accessLimit, *group;
   accessMeth_t am;

	sprintf (header, "Edit File %s", filename);

	if (!userid || !*userid) {
		message = "Cannot write to file because the username is empty.";
	} else if (gstrcmp(var,var2)) { //[RK]Oct/14/02 Bug #39
		message = "Cannot write to file because your passwords do not match.";
	} else if (!umUserExists(userid)) {
		message = "Access Denied: Prohibited user";
	} else {
		accessLimit = umGetAccessLimit("/cfg/WriteTextFile");
		userpass = umGetUserPassword(userid);
		if (userpass) {
			if (gstrcmp(var, userpass) != 0) {
				message = "Access Denied: Wrong password";
			} else if (accessLimit == NULL) {
				message = "Access Denied: You have no permission to modify this file.";
			} else if (!umUserCanAccessURL(userid, accessLimit)) {
				message = "Access Denied: You have no permission to modify this file.";
			} else {
				/* Remove all the <CR> characters */
				for (s=filetext+strlen(filetext)-1; s>=filetext; s--) {
					if (*s == '\r') {
						for (t=s+1; *(t-1); t++) *(t-1)=*t;
					}
				}
				if ((arq = fopen(filename, "w+")) != NULL) {
					setbuf(arq,NULL);
					if (fwrite(filetext, 1, strlen(filetext), arq) != strlen(filetext)) {
						message = "The file was not completely written.";
					} else {
						message = "The file was overwritten";
						error = 0;
					}
					fclose(arq);
				} else {
					message = "The file could not be opened";
				}
			}
			bfree (B_L, userpass);
		}
	}
		
	websCycHdrInit(&hdr);
	hdr.title = header;
	if (*link)
		hdr.father = link;
	else
		hdr.father = "/read/editfile.asp";
	websPageMessage(wp, &hdr, message, error);
}


static void  WriteProfileFile(webs_t wp, char_t *path, char_t *query)
{
	FILE *arq;
	unsigned char *filename = websGetVar(wp, T("filename"), "");
	unsigned char *filetext = websGetVar(wp, T("filetext"), "");
	unsigned char *filedir = "/web/appl/profiles/";
	unsigned char *filepath;
	unsigned char *s, *t;
	struct cyc_webs_header hdr;
	unsigned char error=1, *message, header[128];
	int maxsize = (strlen(filedir) + strlen(filename))* sizeof(char);

	filepath = (char *) malloc(maxsize);
	strcpy(filepath, filedir);
	strcat(filepath, filename);
	/* Remove all the <CR> characters */
	for (s=filetext+strlen(filetext)-1; s>=filetext; s--) {
		if (*s == '\r') {
			for (t=s+1; *(t-1); t++) *(t-1)=*t;
		}
	}
	if ((arq = fopen(filepath, "w+")) != NULL) {
		setbuf(arq,NULL);
		if (fwrite(filetext, 1, strlen(filetext), arq) != strlen(filetext)) {
			message = "error";
		} else {
			message = "success";
			error = 0;
		}
		fclose(arq);
	} else {
		message = "error";
	}
	free(filepath);
	websCycHdrInit(&hdr);
	hdr.title = "Profile";
	hdr.father = "/goform/cfg/WriteProfileFile";
	websPageMessage(wp, &hdr, message, error);
}

static void  ReadDirList(webs_t wp, char_t *path, char_t *query)
{
	struct dirent *dentry;
	DIR *dpntr;
	int maxsize;
	char_t *message = NULL, *message1 = NULL;
	struct cyc_webs_header hdr;
	dpntr = opendir("/web/appl/profiles");
	if(dpntr == 0)
		fmtAlloc(&message, 10, T("error|"));
	else{
		dentry = readdir(dpntr);
		fmtAlloc(&message1, 10, T("success|"));
		while(dentry != 0)
		{
			if( (strcmp(dentry->d_name, ".") == 0) || (strcmp(dentry->d_name, "..") == 0) )
			{
				dentry = readdir(dpntr);
				continue;
			}
			message = NULL;
			maxsize = strlen(message1) + strlen(dentry->d_name) + 2;
			fmtAlloc(&message, maxsize, T("%s%s|"), message1, dentry->d_name);
			message1 = message;
			dentry = readdir(dpntr);		
		}
	}
	websCycHdrInit(&hdr);
	hdr.title = "DirList"; 
	hdr.father = "/goform/cfg/ReadDirList";
	if(message == NULL)
		websPageMessage(wp, &hdr, message1, error);
	else
		websPageMessage(wp, &hdr, message, error);
	if(message != NULL)
		bfree(B_L, message);
	bfree(B_L, message1);
}
static void HandleSysUsr(webs_t wp, char_t *path, char_t *query)
{
	FILE *arq;
	unsigned char user[32], header[64], buffer[128];
	unsigned char *s, *message, error = 1;
	unsigned char *opt = websGetVar(wp, "opt", "");
	unsigned char *entry = websGetVar(wp, "entry", NULL);
	
	if (entry) {
		strncpy(user, entry, 31);
		for (s=user; s-user<31 && *s!=':'; s++);
		*s=0;
	} else {
		user[0] = 0;
	}
	if (*opt == 'A') {
		websRedirect(wp, "/cfg/addsysusr.asp", NULL);
		return;
	}
	
	if (strcmp(user, "root") == 0) {
		strcpy (header, "System User Management");
		message = "No operation is allowed with the user root.";
	} else if (*opt == 'D') {
		sprintf(header, "Delete the User %s", user);
		if (entry) {
			sprintf(buffer, "deluser %s>/tmp/webtemp 2>/dev/null", user);
			system(buffer);
			if ((arq = fopen("/tmp/webtemp", "r")) != NULL) {
				buffer[fread(buffer, 1, 127, arq)]=0;
				fclose(arq);
			}
			system("rm -f /tmp/webtemp");
			if (!(*buffer)) {
				sprintf (buffer, "The user %s was deleted successfully.", user);
			}
			message = buffer;
			error = 0;
		} else {
			message = "No user selected";
		}
	} else if (*opt == 'C') {
		if (entry) {
			sprintf(header, "Change Password for %s", user);
		} else {
			strcpy(header, "System Users");
			message = "No user selected";
		}
	}
	if (strcmp(user, "root") && *opt=='C' && entry) {
		struct cyc_webs_header hdr;
		websCycHdrInit(&hdr);
		hdr.need_header = 1;
		hdr.title = header;
		hdr.form = "cfg/ConfChgPasswd";
		hdr.links = "&nbsp;<a href=\"/goform/ShowSysUsrTable\">"
			"[User Table]</a>";
		hdr.father = "/goform/ShowSysUsrTable";
		websPageStart(wp, &hdr);
		websWrite(wp, "<input type=\"hidden\" name=\"username1\" value=\"%s\">", user);
		websWrite(wp,"<center><table border align=\"center\"><tr><th class=\"tt\" colspan=\"2\">%s</th></tr>",header);
		websWrite(wp,"<tr><td><b>Password</b></td><td><input class=\"tx\" type=\"password\" name=\"passwd1\"></td></tr>"
			"<tr><td><b>Confirm</b></td><td><input class=\"tx\" type=\"password\" name=\"passwd2\"></td></tr>"
			"</table></center><br><center><input type=\"submit\" value=\"Submit\"></center>");
		websPageEnd(wp, &hdr);
	} else {
		struct cyc_webs_header hdr;
		websCycHdrInit(&hdr);
		hdr.title = header;
		hdr.father = "/goform/ShowSysUsrTable";
		hdr.links = "&nbsp;<a href=\"/goform/ShowSysUsrTable\">"
			"[User Table]</a>";
		websPageMessage(wp, &hdr, message, error);
	}
}

//========================================================================
// Handles special characters for shell
//========================================================================

static char mustBeEscaped[] = "#()'\";<>`\\?*&";
static char escapedName[128];

static char *EscapeUserPasswd(char *str)
{
	int i = 0;

	for ( ; *str; ) {
		if (strchr(mustBeEscaped, *str)) {
			escapedName[i++] = '\\';
		}
		escapedName[i++] = *str++;
	}

	escapedName[i] = 0;
	return(escapedName);
}

static void ConfChgPasswd(webs_t wp, char_t *path, char_t *query)
{
	FILE *arq;
	unsigned char *var, *var2, *user, *message;
	unsigned char buffer[256], header[64], error=1;
	struct cyc_webs_header hdr;
	
	user = websGetVar(wp, T("username1"), "");
	sprintf(header, "Change Password for User %s", user);
	if (strcmp(user, "root") == 0) {
		message = "No operation is allowed with the user root.";
	} else {
		message=buffer;
		var = websGetVar(wp, T("passwd1"), "");
		var2 = websGetVar(wp, T("passwd2"), "");
		if (gstrcmp(var, var2) != 0) {
          strcpy(message, "ERROR: Confirmation Password did not match.");
      } else {
			arq = fopen("/tmp/webtemp", "w");
			fprintf(arq, "%s\n%s\n", var, var2);
			fclose(arq);
			sprintf(buffer, "passwd -p %s</tmp/webtemp >/tmp/webtemp2 2>/tmp/webtemp2", EscapeUserPasswd(user));
			system(buffer);
			system("rm -f /tmp/webtemp");
			if ((arq = fopen("/tmp/webtemp2", "r")) != NULL) {
				buffer[fread(buffer, 1, 256, arq)]=0;
				fclose(arq);
			}
			system("rm -f /tmp/webtemp2");

			if (!(*buffer)) {
				sprintf (message, "The password for user %s was successfully changed.", user);
				error = 0;
			}
		}
	}
	websCycHdrInit(&hdr);
	hdr.title = header;
	hdr.father = "/goform/ShowSysUsrTable";
	hdr.links = "&nbsp;<a href=\"/goform/ShowSysUsrTable\">"
		"[User Table]</a>";
	websPageMessage(wp, &hdr, message, error);
}

static void ConfAddSysUsr(webs_t wp, char_t *path, char_t *query)
{
	unsigned char *var, *userid, *var2, error=1, size;
	unsigned char buffer[256];
	FILE *arq;
	struct cyc_webs_header hdr;
	websCycHdrInit(&hdr);
	hdr.title = "Add a System User";
	hdr.father = "/goform/ShowSysUsrTable";
	hdr.links = "&nbsp;<a href=\"/goform/ShowSysUsrTable\">"
		"[User Table]</a>";

	userid = websGetVar(wp, T("username1"), "");
	var = websGetVar(wp, T("passwd1"), "");
	var2 = websGetVar(wp, T("passwd2"), "");
	//[RK]Oct/09/02 - Bug DIGI # 9390 - verify password
	if (gstrcmp(var,var2)) { //[RK]Oct/14/02 Bug #39
		websPageMessage(wp, &hdr, "Passwords do not match", error);
		return;
	}
	if (!userid || !*userid) {
		websPageMessage(wp, &hdr, "Empty username", error);
		return;
	}
	if (*var) {
		strcpy(buffer, "adduser -P ");
		strcat(buffer, EscapeUserPasswd(var));
	} else {
		strcpy(buffer,"adduser ");
	}
	var = websGetVar(wp, T("homedir"), NULL);
	if (var && *var) {
		strcat(buffer, " -h ");
		strcat(buffer, var);
	}
	var = websGetVar(wp, T("shell"), NULL);
	if (var && *var) {
		sprintf(&buffer[strlen(buffer)], " -s \042%s\042", var);
	}
	var = websGetVar(wp, T("group1"), NULL); // Regina Kodato - Apr/16/02
	if (var && *var) {
		if (strcmp(var,"default")) {
			strcat(buffer, " -g ");
			strcat(buffer, var);
		}
	}
	var = websGetVar(wp, T("comment"), NULL);
	if (var && *var) {
		strcat(buffer, " -c ");	//Regina Kodato - Apr/16/02
		size = strlen(buffer);
		buffer[size] = '"';
		buffer[size+1] = 0x00;
		strcat(buffer, var);
		buffer[size=strlen(buffer)] = '"';
		buffer[size+1] = 0x00;
	}
	var = websGetVar(wp, T("username1"), "");
	strcat(buffer, " ");
	strcat(buffer, EscapeUserPasswd(var));
	strcat(buffer, "</dev/null >/tmp/webtemp2 2>/tmp/webtemp2");
	system(buffer);
	if ((arq = fopen("/tmp/webtemp2", "r")) != NULL) {
		buffer[fread(buffer, 1, 256, arq)]=0;
		fclose(arq);
	}
	system("rm -f /tmp/webtemp2");
	error = 0;
	if (!(*buffer)) {
		sprintf(buffer, "The user %s was added.", var);
	}
	websPageMessage(wp, &hdr, buffer, error);
}

static void HandleSysGrp(webs_t wp, char_t *path, char_t *query)
{
	struct cyc_webs_header hdr;
	unsigned char user[64], *s, buffer[64], error = 1;
	unsigned char *opt = websGetVar(wp, "opt", "");
	unsigned char *entry = websGetVar(wp, "entry", NULL);
	if (*opt == 'A') {
		websRedirect(wp, "/cfg/addsysgrp.asp", NULL);
	} else if (*opt == 'D') {
		if (entry) {
			strncpy(user, "delgroup ", 63);
			strncat(user, entry, 63-strlen(user));
			s=user;
			while(*s && *s!=':') s++;
			*s=0;
			system(user);
			sprintf (buffer, "The group %s was deleted.</b></center>", user+8);
			error = 0;
		} else {
			sprintf (buffer, "No group to delete.");
		}
		websCycHdrInit(&hdr);
		hdr.title = "Delete a System Group";
		hdr.father = "/goform/ShowSysGrpTable";
		hdr.links = "&nbsp;<a href=\"/goform/ShowSysGrpTable\">"
			"[Group Table]</a>";
		websPageMessage(wp, &hdr, buffer, error);
	}
}

static void ConfAddSysGrp(webs_t wp, char_t *path, char_t *query)
{
	FILE *arq;
	unsigned char *grpid, *grpname, error = 1;
	unsigned char buffer[1024];
	struct cyc_webs_header hdr;
	websCycHdrInit(&hdr);
	hdr.title = "Add a System Group";
	hdr.father = "/goform/ShowSysGrpTable";
	hdr.links = "&nbsp;<a href=\"/goform/ShowSysGrpTable\">"
		"[Group Table]</a>";

	grpid = websGetVar(wp, T("grpid"), NULL);
	grpname = websGetVar(wp, T("grpname"), "");
	if (!grpname || !*grpname) {
		websPageMessage(wp, &hdr, "Empty User Group", error);
		return;
	}
	strcpy(buffer, "addgroup");
	if (grpid && *grpid) {
		strcat(buffer, " -g ");
		strcat(buffer, grpid);
	}
	strcat(buffer, " ");
	strcat(buffer, grpname);
	strcat(buffer, ">/tmp/webtemp2 2>/tmp/webtemp2");
	system(buffer);
	
	if ((arq = fopen("/tmp/webtemp2", "r")) != NULL) {
		buffer[fread(buffer, 1, 128, arq)]=0;
		fclose(arq);
	}
	system("rm -f /tmp/webtemp2");
	error = 0;
	if (!(*buffer)) {
		sprintf(buffer, "The group %s was successfully added.", grpname);
	}
	websPageMessage(wp, &hdr, buffer, error);
}

static void HandleProc(webs_t wp, char_t *path, char_t *query)
{
	unsigned char user[128], *s;
	unsigned char *str = websGetVar(wp, "nentries", "");
	int i, nentries;
	if (sscanf (str, "%d", &nentries) && nentries) {
		for (i=0; i<nentries; i++) {
			sprintf(user, "entry%d", i);
			if ((str = websGetVar(wp, user, "")) != NULL) {
				strncpy(user, "kill -9 ", 127);
				s=user+strlen(user);
				strncpy(s, str, 127-strlen(user));
				while(isspace(*s)) s++;
				while(*s && !isspace(*s)) s++;
				*s=0;
				system(user);
			}
		}
	}
	websRedirect(wp, "/goform/ShowProcessStatus", NULL);
}

static void HandleSess(webs_t wp, char_t *path, char_t *query)
{
	unsigned char *entry = websGetVar(wp, "entry", NULL);
	DIR *dir;
	struct dirent *direntry;
	struct stat sbuf;
	char statpath[32], buffer[512];
	int tty, ttys;
	char *s, *t;
	int i, fd;
	
	if (entry) {
		s=entry;
		while(isspace(*s)) s++;
		while(*s && !isspace(*s)) s++;
		while(isspace(*s)) s++;
		strcpy(statpath, "/dev/");
		strncat(statpath, s, 20);
		s = statpath;
		while(*s && !isspace(*s)) s++;
		*s=0;
		if(stat(statpath, &sbuf) >= 0) {
			ttys = sbuf.st_rdev;
			if ((dir = opendir("/proc")) != NULL) {
				while ((direntry = readdir(dir)) != NULL) {
					if (!isdigit(*direntry->d_name)) {
						continue;
					}
					sprintf(statpath, "/proc/%s/stat", direntry->d_name);
					if ((fd = open(statpath, O_RDONLY)) != -1) {
						if ((i = read(fd, buffer, 511)) > 0) {
							buffer[i] = 0;
							for (s=buffer, i=0; i<6; i++) {
								while (*s && !isspace(*s)) s++;
								while (isspace(*s)) s++;
							}
							t=s;
							while (*t && !isspace(*t)) t++;
							*t=0;
							if (sscanf(s, "%d", &tty)) {
								if (tty == ttys) {
									snprintf (statpath, 32, "kill -9 %s", direntry->d_name);
									system (statpath);
								}
							}
						}
						close(fd);
					}
				}
				closedir(dir);
			}
		}
	}
	websRedirect(wp, "/goform/ShowActiveSessions", NULL);
}

static void HandleCASSess(webs_t wp, char_t *path, char_t *query)
{
	unsigned char *entry = websGetVar(wp, "entry", NULL);
	char buffer[512];
	char *s, *t;
	int i;

	if (entry) {
		s=entry;
		while(isspace(*s)) s++;
                for (i=0; i<4; i++) {
		        while(*s && !isspace(*s)) s++;
		        while(isspace(*s)) s++;
                }
                t = s;
                while(*t && *t != '/') t++;
                if (*t) *t++ = 0;
                snprintf(buffer, 512, "kill -int %s", s);
                system(buffer);
                sleep(1);
        }
	websRedirect(wp, "/goform/ShowCASSessions", NULL);
}

static void ConfigConfirm(webs_t wp, char_t *path, char_t *query)
{
	FILE *arq, *arq2;
	unsigned char *load = websGetVar(wp, T("load"), "");
	unsigned char *ftpserver = websGetVar(wp, T("ftpserver"), "");
	unsigned char *user = websGetVar(wp, T("user"), "");
	unsigned char *passwd = websGetVar(wp, T("passwd"), "");
	unsigned char *dirname = websGetVar(wp, T("dirname"), "");
	unsigned char buffer[8192];
	unsigned char comm[128];
	int i, size2;
	struct cyc_webs_header hdr;

	if (*(load+strlen(load)-1) == 'h') {
		if (*load=='S') {
			system("saveconf>/tmp/webtemp2 2>&1");
		} else {
			system("restoreconf>/tmp/webtemp2 2>&1");
		}
	} else {
		/* From/to FTP server */
		sprintf(buffer, "%s ftp %s %s %s %s >/tmp/webtemp2 2>&1",
			(*load=='S')? "saveconf" : "restoreconf", 
			dirname, ftpserver, user, passwd); 
		system(buffer);
	}
	/* From/to flash */
	sprintf(comm, "%s Configuration %s %s - Results", (*load == 'S')?"Save":"Load",
		(*load == 'S')?"in":"from", (*(load+strlen(load)-1) == 'h')?"flash":"FTP server");
	if ((arq = fopen("/tmp/webtemp2", "r")) != NULL) {
		size2 = fread(buffer, 1, 8192, arq);
		buffer[size2] = 0;
		fclose(arq);
	}
	system("rm -f /tmp/webtemp2");
	websCycHdrInit(&hdr);
	hdr.title = comm;
	hdr.father = "/adm/config.asp";
	websPageMessage(wp, &hdr, buffer, 0);
}

static void RunConfigConfirm(webs_t wp, char_t *path, char_t *query)
{
	unsigned char *pslave = websGetVar(wp, T("pslave"), NULL);
	unsigned char *snmp   = websGetVar(wp, T("snmp"), NULL);
	unsigned char *syslog = websGetVar(wp, T("syslog"), NULL);
	unsigned char message[512];
	struct cyc_webs_header hdr;
	int temp = 0; 
	message[0] = 0;

	if (pslave) {
		system("/bin/signal_ras hup");
      strncat(message, "<br>Serial Ports/Ethernet/Routing Table configuration reloaded.", 512);
		temp = 1;
	}
	if (snmp) {
		system("/bin/signal_ras snmp hup");
      strncat(message, "<br>SNMP configuration reloaded.", 512);
		temp = 1;
	}
	if (syslog) {
		system("/bin/signal_ras syslog hup");
      strncat(message, "<br>Syslog configuration reloaded.", 512);
		temp = 1;
	}
	if (!temp) {
      strncat(message, "<b class=err><center>Error: No configuration was chosen.</center></b>", 512);
	}
	websCycHdrInit(&hdr);
	hdr.title = "Run Configuration";
	hdr.father = "/adm/runconfig.asp";
	websPageMessage(wp, &hdr, message, 0);
}

static void zImageConfirm(webs_t wp, char_t *path, char_t *query)
{
	FILE *arq;
	unsigned char *load = websGetVar(wp, T("load"), "");
	unsigned char *ftpserver = websGetVar(wp, T("ftpserver"), "");
	unsigned char *user = websGetVar(wp, T("user"), "");
	unsigned char *passwd = websGetVar(wp, T("passwd"), "");
	unsigned char *dirname = websGetVar(wp, T("dirname"), "");
	unsigned char *filename = websGetVar(wp, T("filename"), "");
	unsigned char buffer[2000] = {0};
	int size;
	struct cyc_webs_header hdr;
	
	if (*load=='D') {
		snprintf(buffer, 100, "ftpget -u %s -p %s %s /proc/flash/zImage %s/%s >/tmp/webtemp2 2>&1", user,passwd,ftpserver,dirname,filename);
	} else {
		snprintf(buffer, 100, "cd /proc/flash;ftpput -u %s -p %s %s %s/%s zImage >/tmp/webtemp2 2>&1", user,passwd,ftpserver,dirname, filename);
	}
	system(buffer);
	if ((arq = fopen("/tmp/webtemp2", "r")) != NULL) {
		size = fread(buffer, 1, sizeof(buffer), arq);
		buffer[size] = 0;
		fclose(arq);
		if (size == 0) {
			sprintf(buffer,"%s Image executed successfully",(*load == 'D')?"Download":"Upload");
		}
	}
	
	system("rm -f /tmp/webtemp2");
	websCycHdrInit(&hdr);
	hdr.title = "FTP Results";
	hdr.father = "/adm/zimage.asp";
	websPageMessage(wp, &hdr, buffer, 0);
//	exit(0);
}

static unsigned char *ProcStatus(unsigned char *comm, unsigned char *sess)
{
	int i;
	FILE *arq;
	unsigned char *s, *t1, *t2;

	system("ps>/tmp/webtemp");
	if ((arq = fopen("/tmp/webtemp", "r")) != NULL) {
		while (fgets(sess, 128, arq)!=NULL) {
			s=sess;
			while(isspace(*s)) s++;
			t1=s;
			for (i=0; i<4; i++) {
				while (*s && !isspace(*s)) s++;
				if (i==0) *s++=0;
				while (isspace(*s)) s++;
			}
			t2=s;
			while (*t2 && !isspace(*t2)) t2++;
			if (strncmp(t2-strlen(comm), comm, strlen(comm))== 0 &&
				(s==t2-strlen(comm) || *(t2-strlen(comm)-1)=='/')) {
				fclose(arq);
				return t1;
			}
		}
		fclose(arq);
	}
	system("rm -f /tmp/webtemp");
	return NULL;
}

static int CheckProcStatus(int eid, webs_t wp, int argc, char_t **argv)
{
	unsigned char *active, *comm, sess[128];
	ejArgs(argc, argv, "%s", &comm);
	active = ProcStatus(comm, sess);

	websWrite(wp, "<td><align=\"left\"><b>\%s</b></td><td><b>%s</b></td><td><input type=\"submit\" name=\"%s\" value=\"%s\">",
		comm, (active)?"Active":"Inactive", comm, (active)?"Stop":"Start");

	websWrite(wp, "</td>");
	return 0;
}


/*
 * PS. Whenever a program is add to restproc.asp it MUST be added here also.
*/

struct OPT_NAMES {
	char *name;
	char *nick;
	int  sleep;
};

/*
 * The second column is the nickname in daemon_list
*/
static struct OPT_NAMES opt_names[] = {
	{"cy_ras",          NULL,       5 },
	{"cy_buffering",    NULL,       1 },
	{"inetd",           "NET",      1 },
	{"sshd",            "SSH",      1 },
	{"snmpd",           "SNMP",     1 },
	{"syslog-ng",       "LOG",      1 },
	{"ntpclient",       "NTP",      1 },
	{"pmd",             "PMD",      1 },
	{NULL,              NULL,       1 }
};

static void RestProc(webs_t wp, char_t *path, char_t *query)
{
	unsigned char sess[128], comm[64], *s, *active, *opt;
	struct OPT_NAMES *p;
	int action;

	for (p=&opt_names[0]; p->name; p++) {
		opt = websGetVar(wp, p->name, "");
		if (opt  && *opt) break;
	}

	if ((s = p->name) == NULL) {
		goto rot_exit;
	}

	if (strncmp(opt, "Stop", 4) == 0) {
		action = 1;
	} else if (strncmp(opt, "Start", 5) == 0) {
		action = 2;
	} else if (strncmp(opt, "Restart", 7) == 0) {
		action = 3;
	}

	active = ProcStatus(s, sess);

	if ((action&1) && active) {
		if (strcmp(s, "cy_ras") == 0 ||
			strcmp(s, "cy_buffering") == 0) {
			sprintf(comm, "killall -INT %s", s);
			system(comm);
		} else {
			sprintf(comm, "daemon.sh stop %s", p->nick);
			system(comm);
		}
		active=NULL;
	}
	if ((action&2) && !active) {
		if (strcmp(s, "cy_ras") == 0 ||
			strcmp(s, "cy_buffering") == 0) {
	    	sprintf(comm, "%s &", s);
	    	system(comm);
	    } else {
	    	sprintf(comm, "daemon.sh %s", p->nick);
	    	system(comm);
	    }
	}
	if (p->sleep) {
		sleep (p->sleep);
	}
rot_exit:
	websRedirect(wp, "/adm/restproc.asp", NULL);
}

static void HandleRoute(webs_t wp, char_t *path, char_t *query)
{
	FILE *arq;
	unsigned char route[256], *s, *t, addr[16], mask[16], error = 1;
	unsigned char *opt = websGetVar(wp, "opt", "");
	unsigned char *entry = websGetVar(wp, "entry", NULL);
	struct cyc_webs_header hdr;
	if (*opt == 'D') {
		if (entry) {
			strncpy(route, entry, 256);
			s=route;
			while(isspace(*s)) s++;
			while(*s && !isspace(*s)) s++;
			if (*s) *s++=0;
			if (strcmp(route, "default") == 0) {
				strcpy(addr, "0.0.0.0");
			} else {
				strcpy(addr, route);
			}
			while(isspace(*s)) s++;
			while(*s && !isspace(*s)) s++;
			while(isspace(*s)) s++;
			t=s;
			while(*s && !isspace(*s)) s++;
			if (*s) *s++=0;
			strcpy(mask, t);
			sprintf(route, "route del -net %s netmask %s >/tmp/webtemp2 2>/tmp/webtemp2",
				addr, mask);
			system(route);
			if ((arq = fopen("/tmp/webtemp2", "r")) != NULL) {
				route[fread(route, 1, 255, arq)]=0;
				fclose(arq);
			}
			system("rm -f /tmp/webtemp2");
		}
		if (entry) {
			if (!(*route)) {
				sprintf(route, "Route to %s/%s deleted.", addr, mask);
				error = 0;
			}
		} else {
			strcpy(route, "No route to delete.");
		}
		websCycHdrInit(&hdr);
		hdr.title = "Delete Route";
		hdr.father = "/goform/ShowRouteTable";
		hdr.links = "&nbsp;<a href=\"/goform/ShowRouteTable\">"
			"[Routing Table]</a>";
		websPageMessage(wp, &hdr, route, error);
	}
	if (*opt == 'A') {
		websRedirect(wp, "/adm/addroute.asp", NULL);
	}
}

static void ConfAddRoute(webs_t wp, char_t *path, char_t *query)
{
	FILE *arq;
	unsigned char buffer[256], error = 1;
	unsigned char *message;
	struct in_addr inp;
	unsigned char *dest = websGetVar(wp, T("dest"), "");
	unsigned char *go_to = websGetVar(wp, T("goto"), "");
	unsigned char *net = websGetVar(wp, T("net"), "");
	unsigned char *mask = websGetVar(wp, T("mask"), "");
	unsigned char *ip = websGetVar(wp, T("ip"), "");
	unsigned char *gw = websGetVar(wp, T("gw"), "");
	unsigned char *itf = websGetVar(wp, T("itf"), "");
	struct cyc_webs_header hdr;
	websCycHdrInit(&hdr);
	hdr.title = "Add a Route";
	hdr.links = "&nbsp;<a href=\"/goform/ShowRouteTable\">"
		"[Routing Table]</a>";
	hdr.father = "/goform/ShowRouteTable";

	/* Checking for errors */
	message = NULL;
	if (*dest < '0' || *dest > '2') {
		message = "Wrong destination option.";
	} else if (*dest == '1' && !inet_aton(net, &inp) && 
		!inet_aton(mask, &inp) ) {
		message = "Network is not valid.";
	} else if (*dest == '2' && !inet_aton(ip, &inp)) {
		message = "Host IP address is not valid.";
	} else if (*go_to != '0' && *go_to != '1') {
		message = "Routing option is not valid.";
	} else if (*go_to == '0' && !inet_aton(gw, &inp)) {
		message = "Gateway address is not valid.";
	} else if (*go_to == '1' && !*itf) {
		message = "Interface field is empty.";
	}
	if (message) {
		websPageMessage(wp, &hdr, message, error);
		return;
	}
	strcpy(buffer, "route add ");
	switch (*dest) {
		case '0':
			strcat(buffer, "default ");
			break;
		case '1':
			sprintf(buffer+strlen(buffer), "-net %s netmask %s ",
				net, mask);
			break;
		case '2':
			sprintf(buffer+strlen(buffer), "-host %s ", ip);
			break;
	}
	switch (*go_to) {
		case '0':
			sprintf(buffer+strlen(buffer), "gw %s ", gw);
			break;
		case '1':
			sprintf(buffer+strlen(buffer), "dev %s ", itf);
			break;
	}
	strcat(buffer, ">/tmp/webtemp2 2>/tmp/webtemp2");
	system(buffer);
	
	if ((arq = fopen("/tmp/webtemp2", "r")) != NULL) {
		buffer[fread(buffer, 1, 255, arq)]=0;
		fclose(arq);
	}
	system("rm -f /tmp/webtemp2");
	if (!(*buffer)) {
		strcpy (buffer, "The route was successfully added.");
		error = 0;
	}
	websPageMessage(wp, &hdr, buffer, error);
}

#ifdef CONFIG_SM100
static void ServerManagement(webs_t wp, char_t *path, char_t *query)
{
	FILE *arq;
	unsigned char *s, *active, *opt, flag=0, buf[256];
	opt = websGetVar(wp, "ipmi", T(""));
	if (*opt) {
		/* ipmi */
		s = opt;
		while (*s && !isspace(*s)) s++;
		while (isspace(*s)) s++;
		if (strncmp(opt, "Power On", 8) == 0) {
			system("/bin/sm ipmi on");
		} else if (strncmp(opt, "Power Off", 9) == 0) {
			system("/bin/sm ipmi off");
		} else if (strncmp(opt, "Power Cycle", 11) == 0) {
			system("/bin/sm ipmi cycle");
		} else if (strncmp(opt, "HW Reset", 8) == 0) {
			system("/bin/sm ipmi reset");
		} else if (strncmp(opt, "Get Status", 10) == 0) {
			system("/bin/sm sensor status > /tmp/sensor");
			if ((arq = fopen("/tmp/sensor", "r")) != NULL) {
				buf[fread(buf, 1, 255, arq)]=0;
				fclose(arq);
			}
			system("rm -f /tmp/sensor");
			flag |= 2;
		}
		flag |= 1;
	}
	opt = websGetVar(wp, "atx", T(""));
	if (*opt) {
		/* atx */
		s = opt;
		while (*s && !isspace(*s)) s++;
		while (isspace(*s)) s++;
		if (strncmp(opt, "Power On", 8) == 0) {
			system("/bin/sm atx on");
		} else if (strncmp(opt, "Power Off", 9) == 0) {
			system("/bin/sm atx off");
		} else if (strncmp(opt, "Power Cycle", 11) == 0) {
			system("/bin/sm atx cycle");
		} else if (strncmp(opt, "Get Status", 10) == 0) {
			system("/bin/sm sensor status > /tmp/sensor");
			if ((arq = fopen("/tmp/sensor", "r")) != NULL) {
				buf[fread(buf, 1, 255, arq)]=0;
				fclose(arq);
			}
			system("rm -f /tmp/sensor");
			flag |= 2;
		}
		//flag |= 0;
	}

	switch (flag) {
		case 0:
			websRedirect(wp, "/adm/sm_atx.asp", NULL);
			break;
		case 1:
			websRedirect(wp, "/adm/sm_ipmi.asp", NULL);
			break;
		case 2:
		case 3:
		{
			struct cyc_webs_header hdr;
			websCycHdrInit(&hdr);
			hdr.title = "Temperature/Voltage Status";
			hdr.father = (flag == 2)?
				"/adm/sm_atx.asp":"/adm/sm_ipmi.asp";
			websPageMessage(wp, &hdr, buf, 0);
			break;	
		}
	}
}
#endif

int WebGetIOInfo(int eid, webs_t wp, int argc, char_t **argv)
{
	FILE *arq;
    unsigned char buffer[512];
    unsigned char *name;
    unsigned char *value;
    int i, j=0;

	system("/bin/pu -r -d /dev/gpio -l > /tmp/gpio_web");
	if ((arq = fopen("/tmp/gpio_web", "r"))!= NULL) {
		websWrite (wp, T("<tr>"));
        websWrite (wp, T("<th colspan=\"2\" class=\"tt\" width=230 align=\"center\">   Digital Port Information  </th>"));
        websWrite (wp, T("</tr>"));
        while (fgets(buffer, 512, arq)) {
        	if (j++<1) continue; /* Filter first line out */
	        value = name = buffer;
            for (i = 0; i < 30; i++) {
				if (*value == '-') break;
            	value++;
            }
            if (i == 30) break;
            *value = 0;
            value++;
			websWrite (wp, T("<tr>"));
            websWrite (wp, T("<td><b>%s</b></td><td>%s</td>"), name, value);
			websWrite (wp, T("</tr>"));
		}
		fclose(arq);
    }
	system("rm -f /tmp/gpio_web");

	j = 0;
	system("/bin/pu -r -d /dev/adc1 > /tmp/adc1_web");
	if ((arq = fopen("/tmp/adc1_web", "r"))!= NULL) {
		websWrite (wp, T("<tr>"));
        websWrite (wp, T("<th colspan=\"2\" class=\"tt\" width=230 align=\"center\">   Analog Port Information  </th>"));
        websWrite (wp, T("</tr>"));
        j = 1;
        while (fgets(buffer, 512, arq)) {
	        value = buffer;
			websWrite (wp, T("<tr>"));
            websWrite (wp, T("<td><b>%s</b></td><td>%s</td>"), "port 1", value);
			websWrite (wp, T("</tr>"));
		}
		fclose(arq);
    }
	system("rm -f /tmp/adc1_web");

	system("/bin/pu -r -d /dev/adc2 > /tmp/adc2_web");
	if ((arq = fopen("/tmp/adc2_web", "r"))!= NULL) {
		if (!j) {
			websWrite (wp, T("<tr>"));
	        websWrite (wp, T("<th colspan=\"2\" class=\"tt\" width=230 align=\"center\">   Analog Port Information  </th>"));
	        websWrite (wp, T("</tr>"));
        }
        while (fgets(buffer, 512, arq)) {
	        value = buffer;
			websWrite (wp, T("<tr>"));
            websWrite (wp, T("<td><b>%s</b></td><td>%s</td>"), "port 2", value);
			websWrite (wp, T("</tr>"));
		}
		fclose(arq);
    }
	system("rm -f /tmp/adc2_web");

    return 0;
}

/*==========================================================================
                PM8 management
==========================================================================*/
#ifdef WEBS_PMD

#define MAX_OUTLETS_PER_IPDU    128
void GetStatusCyclades (webs_t wp, FILE *arq, int noutlets,
        unsigned char *buffer, unsigned char **status)
{
        /* The format of the PM8 status is

        Output          Status          User

        1               Locked ON       mangesh
        2               Locked OFF      root
        */
        unsigned char line[128],*pbuf=buffer;
        unsigned char *q, *r;
        int on, lock, outlet;

        while (! feof(arq)) {
                if (!fgets(line, 128, arq)) break;
                r = line;
                while (!isdigit(*r)) r++;
                if (!(*r)) continue;
		q=r;
		while (isdigit(*r)) r++;
		*r++ = 0x00;
		outlet = atoi(q);
		if ((outlet < 1) || (outlet > MAX_OUTLETS_PER_IPDU)) continue;
                on = 0;
                lock = 0;
                while (*r && isspace(*r)) r++;
                while (*r) {
                        q = r;
                        while (*r && !isspace(*r)) r++;
                        if (((r-q) == 2) && (strncmp(q, "ON", 2) == 0)) {
                                on = 1;
                        } else if (((r-q) == 3) && (strncmp(q, "OFF", 3) == 0)) {
                                on = 2;
                        }
                        if (((r-q) == 6) && (strncmp(q, "Locked", 6) == 0)) {
                                lock = 1;
                        }
                        while (isspace(*r)) r++;
                }
		memset(line,0,128);
                if (on) {
                        sprintf(line, "%s&nbsp;%s",
                                (on==1)?"<img src=\"/lon.gif\">"
                                "":"<img src=\"/loff.gif\">",
                                lock?"<img src=\"/lock.gif\">":"");
                } 
                status[outlet-1] = pbuf;
		strcpy(pbuf,line);
		pbuf += strlen(line);
		*pbuf++ = 0x00;
        }
}

#if 0  //[RK]Aug/13/04 - removed support to another IPDUs
void GetStatusSentry (webs_t wp, FILE *arq, int noutlets,
        unsigned char *buffer, unsigned char **status)
{
        /* The format of the sentry status is
	 *  Port  Port      Group     Control   Module
	 *   ID   Name      Name      Status    Status
	 *
	 *   .A1  1                   On        Normal
	 *   .A2  2                   On        Normal
	 *   .A3  3                   Off       Normal
	 *   .A4  4                   Off       Normal
	 *   .B1  5                   On        Normal
	 *   .B2  6                   On        Normal
	 *   .B3  7                   On        Normal
	 *   .B4  8                   On        Normal
         */
        int line = 0;
        unsigned char *r, *s = buffer;
        int on, outlet;
        while (! feof(arq)) {
                if (!fgets(s, buffer + 2048 - s, arq)) break;
                r = s;
                while (isspace(*r)) r++;
                if (!(*r)) continue;
                /* Discard first line */
		line ++;
                if (line < 3) continue;
                outlet = line - 3;
                if (outlet >= MAX_OUTLETS_PER_IPDU) break;
                on = 0;
                if (strstr(s, "On")) {
                        on = 1;
                } else if (strstr(s, "Off")) {
                        on = 2;
                }
                if (on) {
                        if (on == 1) {
                                strncpy(s, "<img src=\"/lon.gif\">",
                                        buffer + 2048 - s);
                        } else {
                                strncpy(s, "<img src=\"/loff.gif\">",
                                        buffer + 2048 - s);
                        }
                }
                status[outlet] = s;
                s += strlen(s);
                *s++ = 0;
        }
}

void GetStatusRPC22 (webs_t wp, FILE *arq, int noutlets,
        unsigned char *buffer, unsigned char **status)
{
        /* The format of the sentry status is
        .
        .
        .
        1)...Outlet 1           :On
        2)...Outlet 2           :Off
        */
        int line = 0;
        unsigned char *r, *s = buffer;
        int on, outlet;
        while (! feof(arq)) {
                if (!fgets(s, buffer + 2048 - s, arq)) break;
                if (sscanf(s, "%d)", &outlet) == 0) continue;
                if (outlet >= MAX_OUTLETS_PER_IPDU) continue;
                on = 0;
                if (strstr(s, "On")) {
                        on = 1;
                } else if (strstr(s, "Off")) {
                        on = 2;
                }
                if (on) {
                        if (on == 1) {
                                strncpy(s, "<img src=\"/lon.gif\">",
                                        buffer + 2048 - s);
                        } else {
                                strncpy(s, "<img src=\"/loff.gif\">",
                                        buffer + 2048 - s);
                        }
                }
                status[outlet - 1] = s;
                s += strlen(s);
                *s++ = 0;
        }
}
#endif

#define BUFLEN	127
unsigned char *OutletUsers(int port, int outlet, unsigned char *buffer)
{
	char *pmusers = lineconf[port-1].pmusers, *s, *t, *u;
	int len = 0, userlen, fim, range, last, first, firstuser = 1;
	buffer[len] = 0;
	if (!pmusers || !*pmusers) {
		return buffer;
	}
        for (s = pmusers; *s; ) {
		u = s;
		while (*s && *s != ':') s++;
		if (*s == 0) {
			/* parse error */
			return buffer;
		} else {
			userlen = s - u;
			s++;
		}
                fim = 0;
                t = s;
                range = 0;
                while(!fim) {
                	if (*s == 0 || *s == ';' || *s == ',') {
	                        if (*s == 0 || *s == ';') {
	                                fim = 1;
	                        }
			       	if (*s) {
	                                s++;
	                        }
	                        if (sscanf (t, "%d", &last) == 0) {
	                                /* parsing error */
                                        return buffer;
                                }
	                        t = s;
                                if (outlet == last || (range && 
					outlet >= first && outlet <= last))  {
					strncpy(buffer+len, u, BUFLEN-len);
					if (len + userlen + 4 > BUFLEN) {
						buffer[BUFLEN] = 0;
						return buffer;
					} else {
						len += userlen;
						strcpy(buffer+len, "<br>");
						len += 4;
						buffer[len] = 0;
					}
				}
				range = 0;
	                } else if (*s == '-') {
	                        s++;
	                        range = 1;
	                        if (sscanf (t, "%d", &first) == 0) {
	                                /* parsing error */
	                                return buffer;
	                        }
         	                t = s;
	                } else {
                                s++;
                        }
                }
        }
        return buffer; // access deny
}

unsigned char *FindTtyForOutlet(int port, int outlet)
{
        unsigned char out[8];
        unsigned char *s, *t;
        int i, found = 0;
        struct line_cfg *pconf;
        snprintf(out, 8, "%d.%d", port, outlet);
        for (i=0, pconf=&lineconf[0]; i < MAXVLINES; i++, pconf++) {
                if (pconf->this != i) {
                        continue;
                }
                if (!pconf->tty || !*pconf->tty) {
                        continue;
                }
                /* Check the outlets */
                if (!pconf->pmoutlet || !*pconf->pmoutlet) {
                        continue;
                }
                s = pconf->pmoutlet;
                while (isspace(*s)) s++;
                while (*s) {
                        t = s;
                        while (*s && !isspace(*s)) s++;
                        if ((s-t == strlen(out)) &&
                                (strncmp(t, out, s-t)==0)) {
                                found = 1;
                                break;
                        }
                        while (isspace(*s)) s++;
                }
                if (found) {
                        break;
                }
        }
        if (found) {
                if (pconf->serverfarm && *(pconf->serverfarm)) {
                        return pconf->serverfarm;
                } else {
                        return pconf->tty;
                }
        }
        return NULL;
}

websShowOutletTable(webs_t wp, int port, int noutlets, ipduInfo2 *ipdu2,
        int statall, unsigned char **status)
{
        int outlet, ret, on, off, lock, unlock, i, j;
        unsigned char command[128], buffer[BUFLEN + 1];
        unsigned char *s, *t;
        struct stat st;
        FILE *arq;

        unsigned char *IPDUOptList[] = {"on", "off", "cycle",
                "lock", "unlock", NULL};
        unsigned char **opt;

        websWrite(wp, "<table border align=\"center\"><tr>"
                "<th class=\"st\">Number</th>"
                "<th class=\"st\">Serial Port</th>"
                "<th class=\"st\">Users</th>"
                "<th class=\"st\">Status</th>");
        if (websGetPriority(wp) >= PRIV_ADMIN) {
                websWrite(wp, "<th class=\"st\">Commands</th>");
        }
        websWrite(wp, "</tr>");

        for (outlet = 1; outlet <= noutlets; outlet ++) {
                s = FindTtyForOutlet(port, outlet);
		t = OutletUsers(port, outlet, buffer);
                websWrite (wp, "<tr><td>%d</td><td>%s</td><td>%s</td><td>", 
			outlet, (s == NULL)?"None":s, 
			(t == NULL || *t == 0)?"None":t);

                /* check status */
                if (statall) {
                        if (status[outlet-1]) {
                                websWrite(wp, status[outlet-1]);
                        } else {
                                websWrite(wp, "Not Available");
                        }
                } else {
                        if (outlet != 1) {
                                snprintf(command, 128, "/bin/pmCommand"
                                        " %d %s %d >%s", port, status[0],
                                        outlet, "/tmp/webtemp");
                                ret = system (command);
                        }
                        if (stat("/tmp/webtemp", &st) || (st.st_size <= 0)) {
                                websWrite(wp, "Not Available");
                        } else {
                                if (ret == -1) websWrite(wp, "Error: ");
                                arq = fopen("/tmp/webtemp", "ro");
                                websWriteTextFile(wp, arq, 1, NULL);
                                fclose(arq);
                        }
                }

                /* Submit buttons */
                if (websGetPriority(wp) < PRIV_ADMIN) {
                        continue;
                }
                websWrite(wp, "<td>");
                if (status[outlet-1]) {
                        on = strstr(status[outlet-1], "<img src=\"/lon.gif\">");
                        off = strstr(status[outlet-1], "<img src=\"/loff.gif\">");
                        lock = strstr(status[outlet-1], "<img src=\"/lock.gif\">");
                        unlock = !lock;
                } else {
                        on = off = lock = unlock = 0;
                }
                for (i = 0, opt = IPDUOptList; *opt; i++, opt++) {
                        if (on && i==0) continue;
                        if (off && i==1) continue;
                        if (off && i==2) continue;
                        if (lock && i==3) continue;
                        if (unlock && i==4) continue;
                        websWrite(wp, "&nbsp;"
                                  "<input type=\"submit\" "
                                  "name=\"opt\" value=\"%s "
                                  "%d:%d\">&nbsp;",
                                   *opt, port, outlet);
                }
                websWrite(wp, "</td>");
        }
        websWrite(wp, "</tr></table>");
}

void ShowPowerMgmtTable(webs_t wp)
{
        FILE *arq;
        int port, noutlets, found, i, j, k, ret, statall;
        struct line_cfg *pconf;
        unsigned char *status[MAX_OUTLETS_PER_IPDU];
        unsigned char command[128];
	unsigned char pmtype[50], *s;
	unsigned char *buffer;
        ipduInfo2 *ipdu2;

	//arq = fopen ("/var/pmd/pmd.info", "r+");
        websWrite(wp, "<center><table border align=\"center\"><tr>"
                "<th class=\"tt\">Serial Port</th>"
                "<th class=\"tt\">Description</th>"
                "<th class=\"tt\">Outlets</th></tr>");
        for (port = 1; port <= MAXVLINES; port ++) {
                pconf = &lineconf[port - 1];
                if (pconf->this != port - 1) {
                        continue;
                }
                if (!pconf->tty || !*pconf->tty) {
                        continue;
                }
                if (pconf->protocol != P_IPDU) {
                        continue;
                }
                /* Serial Port */
                websWrite(wp, "<tr><td>%s</td>", pconf->tty);
                /* Description */
                //noutlets = pconf->pmNumOfOutlets; /* Temporary */
                noutlets = cy_shm->PMD_outlets[port-1]; //[RK]Aug/16/04 
		strncpy(pmtype, pconf->pmtype, 50);
		for (s = pmtype; !isspace(*s) && *s; s++);
		*s = 0;
                websWrite(wp, "<td>Type: %s<br>Outlets: %d<br>Status: ",
                        pmtype, noutlets);
		/* Check the session list */
		if ((ipdu2 = (ipduInfo2 *)cy_shm->sess_list[port - 1]) 
			== NULL) {
                        websWrite(wp, "Not initialized.");
                        websWrite(wp, "</td><td>&nbsp;</td></tr>");
                        continue;
		}
		
                /* If it's possible to get the status for all
                        outlets's, we could parse it now. */
                statall = 1;
		//[RK]Aug/13/04 - removed another IPDUs
		snprintf(command, 128,
                        "/bin/pmCommand %d %s >%s",
                         port, "status all", "/tmp/webtemp");
#if 0 //[RK]Aug/13/04 - remove another IPDUs
                if (strcmp(pmtype, "cyclades") == 0) {
                        snprintf(command, 128,
                                "/bin/pmCommand %d %s >%s",
                                port, "status all", "/tmp/webtemp");
                } else if (strcmp(pmtype, "sentry") == 0) {
                        snprintf(command, 128,
                                "/bin/pmCommand %d %s >%s",
                                port, "report", "/tmp/webtemp");
                } else if (strcmp(pmtype, "rpc22") == 0) {
                        snprintf(command, 128,
                                "/bin/pmCommand %d %s >%s",
                                port, "status", "/tmp/webtemp");
                } else {
                        /* Otherwise, get only the status of the first IPDU */
                        statall = 0;
                        found = 0;
                        for (k=0; k<ipdu2->admMax-1; k++) {
                                if (strcmp("Status",
                                        ipdu2->adminItems[k].label) == 0) {
                                        snprintf(command, 128,
                                                "/bin/pmCommand %d %s %d >"
                                                "%s", port,
                                                ipdu2->adminItems[k].label,
                                                1, "/tmp/webtemp");
                                        found = 1;
                                        break;
                                }
                        }
                        if (! found) {
                                websWrite(wp, "No status command found.");
                                websWrite(wp, "</td><td>&nbsp;</td></tr>");
                                continue;
                        }
                }
#endif
                system (command);
                arq = fopen("/tmp/webtemp", "ro");
		while (!feof(arq)) {
			fgets (command, 128, arq);
	                if (strstr(command, "[Error]")) {
				break;
			}
                }
		if (!feof(arq)) {
                        /* Status returned error! */
                        websWrite(wp, command);
                        websWrite(wp, "</td><td>&nbsp;</td></tr>");
                        continue;
		}
		fgets (command, 128, arq);
		rewind(arq);
                for (i = 0; i < MAX_OUTLETS_PER_IPDU; i++) {
                        status[i] = NULL;
                }
		buffer = malloc(100 * 128);
                /* Parse the status of each outlet */
		GetStatusCyclades (wp, arq, noutlets, buffer, status);
#if 0 //[RK]Aug/13/04 - remove another IPDUs
                if (statall) {
                        if (strcmp(pmtype, "cyclades") == 0) {
                                GetStatusCyclades (wp, arq, noutlets,
                                        buffer, status);
                        } else if (strcmp(pmtype, "sentry") == 0) {
                                GetStatusSentry (wp, arq, noutlets, buffer,
                                        status);
                        } else if (strcmp(pmtype, "rpc22") == 0) {
                                GetStatusRPC22 (wp, arq, noutlets, buffer,
                                        status);
                        }
                } else {
                        status[0] = ipdu2->adminItems[k].command;
                }
#endif
                fclose(arq);
                /* Outlets */
                websWrite(wp, "Detected</td>");
                websWrite(wp, "<td>");
                websShowOutletTable(wp, port, noutlets, ipdu2, statall,
                        status);
                websWrite(wp, "</td></tr>");
        }
        websWrite(wp, "</table></center>");
}

static void PowerMgmt(webs_t wp, char_t *path, char_t *query)
{
        unsigned char *opt = websGetVar(wp, T("opt"), NULL);
        struct line_cfg *pconf;
        struct stat st;
        unsigned char *s, command[128];
        unsigned char buffer[128];
        int port, outlet, i, j, noutlets;
        FILE *arq;
	struct cyc_webs_header hdr;

	websCycHdrInit(&hdr);
	hdr.need_header = 1;
	hdr.title = "Power Management";
	hdr.form = "PowerMgmt";
	hdr.refresh_secs = 60;

        /* Process command if opt is not null */

	if (cy_shm->PMD_pid == 0) {
        	websPageMessage(wp, &hdr, "[Error] - The PMD has not started.", 
				1);
		return;
	}
	websPageStart(wp, &hdr);
        if (websGetPriority(wp) >= PRIV_ADMIN && opt != NULL) {
                s = opt;
                while (*s && !isspace(*s)) s++;
                if (*s) *s++ = 0;
                while (isspace(*s)) s++;
                if (sscanf(s, "%d:%d", &port, &outlet) == 2) {
                        snprintf(command, 128, "/bin/pmCommand %d %s %d >%s",
                                port, opt, outlet, "/tmp/webtemp");
                        system(command);
                        if (stat("/tmp/webtemp", &st) == 0 &&
                                st.st_size > 0) {
                                websWrite(wp, "<br><b><center>");
                                arq = fopen("/tmp/webtemp", "ro");
                                websWriteTextFile(wp, arq, 1, NULL);
                                fclose(arq);
                                websWrite(wp, "</center></b><br>");
                        }
                }
        }
        ShowPowerMgmtTable(wp);
	websPageNoNoteEnd(wp, &hdr);
}
#endif

/*============================================================================
 * DefineWebAspform3 - This is the only routine which is not static. It's
 * called in main.c.
 *============================================================================
 */
void DefineWebAspForm4() {
    websFormDefine(T("adm/RebootConfirm"),     RebootConfirm);
//    websFormDefine(T("adm/PortConv"),          PortConv);
    websFormDefine(T("adm/RunConfigConfirm"),  RunConfigConfirm);
    websFormDefine(T("adm/ConfigConfirm"),     ConfigConfirm);
    websFormDefine(T("adm/zImageConfirm"),     zImageConfirm);
    websFormDefine(T("adm/SetDate"),           SetDate);
    websFormDefine(T("EditTextFile"),          EditTextFile);
    websFormDefine(T("LinkToEditTextFile"),    LinkToEditTextFile);
    websFormDefine(T("cfg/WriteTextFile"),     WriteTextFile);
    websFormDefine(T("cfg/WriteProfileFile"),  WriteProfileFile);
    websFormDefine(T("cfg/HandleSysUsr"),      HandleSysUsr);
    websFormDefine(T("cfg/ReadDirList"), 	ReadDirList);
    websAspDefine (T("PrintGroupSys"), PrintGroupSys); // Regina Kodato - Apr/16/02
    websFormDefine(T("cfg/ConfAddSysUsr"),     ConfAddSysUsr);
    websFormDefine(T("cfg/ConfChgPasswd"),     ConfChgPasswd);
    websFormDefine(T("cfg/HandleSysGrp"),      HandleSysGrp);
    websFormDefine(T("cfg/ConfAddSysGrp"),     ConfAddSysGrp);
    websFormDefine(T("adm/HandleRoute"),       HandleRoute);
    websFormDefine(T("adm/ConfAddRoute"),      ConfAddRoute);
    websFormDefine(T("adm/HandleProc"),        HandleProc);
    websFormDefine(T("adm/HandleSess"),        HandleSess);
    websFormDefine(T("adm/HandleCASSess"),     HandleCASSess);
    websFormDefine(T("adm/RestProc"),          RestProc);

//    websAspDefine (T("PrintSerialPort"),   PrintSerialPort);
//    websAspDefine (T("PrintSpeed"),        PrintSpeed);
    websAspDefine (T("PrintDateOpt"),      PrintDateOpt);
    websAspDefine (T("PrintTimeOpt"),      PrintTimeOpt);
    websAspDefine (T("CheckProcStatus"),   CheckProcStatus);
#ifdef CONFIG_SM100
    websFormDefine(T("adm/ServerManagement"),  ServerManagement);
#endif
#ifdef WEBS_PMD
    websFormDefine (T("PowerMgmt"),         PowerMgmt);
#endif
    websAspDefine(T("WebGetIOInfo"),           WebGetIOInfo);
}
